C-{{{ subroutine bbhweights

      subroutine bbhweights(modin,thdmv,CHmx,Hmx,Amx,lpseudo
     & ,Sindin,tb,muSUSY,lam,GF,deltamb,cdelmb,weH)
!--------------------------------------------------------
!This routine gives the weights between SM and MSSM
!cross sections for bbh in accordance to hep-ph/0305101
!(Guasch, Haefliger, Spira), formula 23.
!February 2012 - S. Liebler
!--------------------------------------------------------
      implicit none
      double precision weH(2)
      double precision deltamb, Hmx(3,3), Amx(3,3), tb
      double precision delmb_in, Sqrt2, vev, vevS, GF, lam, muSUSY
      double complex CHmx(3,3), cdelmb, cweH(2)
      integer i1, modin, thdmv, lpseudo, Sindin
      double precision cbeta, sbeta
      double complex D1, D1C, D2, D2C
      cbeta=dcos(datan(tb))
      sbeta=dsin(datan(tb))

      Sqrt2 = dsqrt(2.d0)
      vev = 1.d0/dsqrt(Sqrt2*GF)
      vevS = muSUSY*Sqrt2/lam
      
      delmb_in = deltamb

!CMSSM
      if (modin.eq.10) then
       D1 = CHmx(Sindin,1)/cbeta + CHmx(Sindin,2)/sbeta*cdelmb
       D1 = D1 / (1.d0 + cdelmb)
       D1C = CHmx(Sindin,1)/cbeta + CHmx(Sindin,2)/sbeta*Conjg(cdelmb)
       D1C = D1C / (1.d0 + Conjg(cdelmb))
       D2 = CHmx(Sindin,3)*(tb - cdelmb/tb)
       D2 = D2 / (1.d0 + cdelmb)
       D2C = CHmx(Sindin,3)*(tb - Conjg(cdelmb)/tb)
       D2C = D2C / (1.d0 + Conjg(cdelmb))
       if (lpseudo.eq.1) then
         cweH(2) = 1/2.d0*(D2 + D2C
     &   - DCMPLX(0.d0,1.d0)* (D1 - D1C))
       else
         cweH(2) = 1/2.d0*(D1 + D1C
     &   + DCMPLX(0.d0,1.d0)* (D2 - D2C))
       endif
      endif

!MSSM and NMSSM
      if ((modin.eq.1).or.(modin.eq.3)) then
       if (lpseudo.eq.1) then
         cweH(1) = Amx(Sindin,2)*tb
         cweH(2) = cweH(1) * (1.d0/(1.d0+delmb_in))
     &        * (1.d0 - (1.d0/tb**2)*delmb_in
     &           - Amx(Sindin,3)*vev/(Amx(Sindin,2)*vevS*tb)*delmb_in)   
       else
         cweH(1) = Hmx(Sindin,1)/cbeta
         cweH(2) = cweH(1) * (1.d0/(1.d0+delmb_in))
     &     * (1.d0 + delmb_in * Hmx(Sindin,2)/(tb*Hmx(Sindin,1))
     & + delmb_in*Hmx(Sindin,3)*vev*cbeta/(Hmx(Sindin,1)*vevS))
       endif
      endif

!2HDM
      if (modin.eq.2) then
         if ((thdmv.eq.1).or.(thdmv.eq.4)) then
          if (lpseudo.eq.1) then
            cweH(1) = -1.d0/tb
          else
            cweH(1) = Hmx(Sindin,2)/sbeta
          endif
         else if ((thdmv.eq.2).or.(thdmv.eq.3)) then
          if (lpseudo.eq.1) then
            cweH(1) = tb
          else
            cweH(1) = Hmx(Sindin,1)/cbeta
          endif
         else
            write(*,*) "2HDM version unknown!"
            stop
         endif
         cweH(2) = cweH(1)
      endif

      do i1=1,2
         weH(i1) = Real(cweH(i1) * Conjg(cweH(i1)))
      end do

      end

C-}}}
