! This file is part of SusHi.
! 
! Interface to Feynhiggs via commandline
! 
! gets inputfile, changes relevant parameters to native FH format,
! gives them to Feynhiggs and then gets the relevant masses back
! 
! afterwards merges FH output and SusHi input to create new inputfile,
! now with given onshell-masses

#include "versions.h"     

      subroutine runcmdfeynhiggs(fsin,fsout)
      implicit none
      character*52 fsin
      character*72 fsout
      character*72 model,processidstr,resultname,final
      character*72 runfcmd1,runfcmd4
      character runfcmd2*36, runfcmd3*13
      character*72 processid
      character fhp1*72,fhp2*72,fhp3*72    
      
      include '../commons/common-slha.f'
      include '../commons/common-vars.f'
      include '../commons/common-citations.f'    
      
      fhp1 = FHPATH1
      fhp2 = FHPATH2
      fhp3 = FHPATH3
      
! get process id and append it to filename to distinguish between dummy files
! if parallel computing

      write(processid,10) getpid()

      processid=adjustl(processid)

      open(unit=14,file=trim("FHresults")//trim(processid))
      
      
!     read in parameters to native FH file format 


      write(14,150) "MT",sminputs(6)
      write(14,150) "MW",Mw
      write(14,150) "MZ",sminputs(4)
      write(14,150) "M3SQ",extpar(43)
      write(14,150) "M3SU",extpar(46)
      write(14,150) "M3SD",extpar(49)
      write(14,150) "M3SL",feynhiggspar(33)
      write(14,150) "M3SE",feynhiggspar(36)
      write(14,150) "M2SQ",feynhiggspar(42)
      write(14,150) "M2SU",feynhiggspar(45)
      write(14,150) "M2SD",feynhiggspar(47)
      write(14,150) "M2SL",feynhiggspar(31)
      write(14,150) "M2SE",feynhiggspar(35)
      write(14,150) "Abs(At)",extpar(11)
      write(14,150) "Abs(Ab)",extpar(12)
      write(14,150) "Abs(Atau)",feynhiggspar(13)
      write(14,150) "MA0",extpar(26)
      write(14,150) "TB",minpar(3)
      write(14,150) "Abs(MUE)",extpar(23)
      write(14,150) "M_2",feynhiggspar(2)
      write(14,150) "M_1",feynhiggspar(1)
      write(14,150) "M_3",extpar(3)

    
 150  format(a,F16.8)       
      close(14)
      
   


      runfcmd1="../"
      runfcmd2="/build/FeynHiggs"
      

      call execute_command_line(trim(fhp1)//
     &trim(fhp2)//
     &trim(fhp3)//
     &trim(runfcmd2)//
     &trim(" FHresults")//trim(processid)//
     &"#SLHA "//
     &"| grep -v %")
     
     
     
      runfcmd3="cat "
      runfcmd4=".fh-001 > "

     
      call execute_command_line(runfcmd3//
     &trim(fsin)//
     &trim(" FHresults")//trim(processid)//
     &trim(runfcmd4)//
     &trim(fsout)//
     &" | grep -v %")
     
      call execute_command_line("rm"//
     &trim(" FHresults")//trim(processid)//
     &trim(" FHresults")//trim(processid)//".fh-001"//" | grep -v %")
     
! include references 

      citations(16) = 1
      citations(17) = 1
      citations(18) = 1
      citations(19) = 1     
  10  format(I10)
  11  format(a)

      end
 
