! This file is part of SusHi.
! 
! Interface to FlexibleSUSY+Himalaya
! 
! Runs FS+H with parameters given bz SusHi inputfile,
! resulting SLHA file is merged with inputfile, which
! then is further used as the new input, now with
! a given OS mass spectrum


#include "versions.h"   

      subroutine runcmdfsh(fsin,fsout)
      implicit none
      character*52 fsin
      character*72 fsout
      character*72 model,runcmd
      character*72 runcmd2,runcmd3,runcmd4,runcmd5,runcmd6
      character*72 runcmdpath1,runcmdpath2,runcmdpath3
      include '../commons/common-citations.f'

! specify model here (name models/$file)  
! should be compatible with SusHi Higgs-parameter set (mu+mA)

      model="NUHMSSMNoFVHimalaya"


      runcmdpath1=FSHPATH1
      runcmdpath2=FSHPATH2
      runcmdpath3=FSHPATH3
!      runcmd1="/net/home/lxtsfs1/tpe/moos/Documents/Masterarbeit/FlexibleSUSY-1.7.4-Himalaya"
      runcmd2="/models/"
      runcmd3="/run_"
      runcmd4=".x"
      runcmd5=" --slha-input-file="
      runcmd6=" --slha-output-file="

      call execute_command_line(trim(runcmdpath1)//
     &trim(runcmdpath2)//
     &trim(runcmdpath3)//
     &trim(runcmd2)//
     &trim(model)//
     &trim(runcmd3)//
     &trim(model)//
     &trim(runcmd4)//
     &trim(runcmd5)//
     &trim(fsin)//
     &trim(runcmd6)//
     &trim(fsout))
     
! include references 
      citations(65) = 1
      citations(66) = 1
      citations(67) = 1     
      citations(68) = 1
      citations(69) = 1     

      end

