! This file is part of SusHi.
! 
! Interface to THDMC via commandline
!
! Relevant Parameters for respective basis are extracted from
! SusHi inputfile and given via commandline to 2HDMC
! resulting SLHA file is concatenated with old input file 
! to create new input file 

#include "versions.h"   

      subroutine runcmdthdmc(fsin,fsout)
      
      implicit none
      integer jc_len
      character(*) fsin
      character(*) fsout
      character*60 resultname
      character runfcmd1*72,runfcmd4*72,runfcmd2*36, runfcmd3*13
      character fhvers*20,hbvers*20,hsvers*20,thdmcvers*72
      common /vers/ fhvers,hbvers,hsvers,thdmcvers
      character*72 lam1,lam2,lam3,lam4,lam5,lam6,lam7,m12,tanbeta
      character*72 mh2hdmc,mhh2hdmc,ma2hdmc,mhp2hdmc
      character*72 cosba,sinba,z4,z5,z7
      character*20 processid
      character thdmcp1*72,thdmcp2*72,thdmcp3*72
    
      include '../commons/common-inputoutput.f'      
      include '../commons/common-slha.f'
      include '../commons/common-vars.f'
      include '../commons/common-ren.f'
      include '../commons/common-citations.f'
      include '../commons/common-quark.f'

      thdmcvers =
     &THDMCVERSION
      write(6,*) 'Using 2HDMC version '//
     &THDMCVERSION     

      thdmcp1 = THDMCPATH1
      thdmcp2 = THDMCPATH2
      thdmcp3 = THDMCPATH3

! get process id and append it to filename to distinguish between dummy files
! if parallel computing

      write(processid,10) getpid()
 10   format(I10)
 
      processid=adjustl(processid)
      resultname = trim(" 2HDMCresults")//trim(processid)//trim(".out")

! Lambda Basis

      if (thdmcpar(11).ne.0) then
      
        write(lam1,*) thdmcpar(11)
        write(lam2,*) thdmcpar(12)
        write(lam3,*) thdmcpar(13)
        write(lam4,*) thdmcpar(14)
        write(lam5,*) thdmcpar(15)
        write(lam6,*) thdmcpar(16)
        write(lam7,*) thdmcpar(17)
        write(m12,*)  thdmcpar(4)*thdmcpar(4)
        write(tanbeta,*) thdmcpar(3)
      
        call execute_command_line(trim(thdmcp1)//
     &trim(thdmcp2)//
     &trim(thdmcp3)//
     &"/CalcGen"//
     &trim(lam1) //
     &trim(lam2) // 
     &trim(lam3) //
     &trim(lam4) //
     &trim(lam5) //
     &trim(lam6) //
     &trim(lam7) //
     &trim(m12) //
     &trim(tanbeta) //
     &" 2" //
     &trim(resultname))

        thdmckey = 1
        tparam(1) = thdmcpar(11)
        tparam(2) = thdmcpar(12)
        tparam(3) = thdmcpar(13)
        tparam(4) = thdmcpar(14)
        tparam(5) = thdmcpar(15)
        tparam(6) = thdmcpar(16)
        tparam(7) = thdmcpar(17)
        thdmcm12 = thdmcpar(4)
      
! Hybrid basis 

      else if (thdmcpar(33).ne.0) then
      
        write(Mh2HDMC,*)  thdmcpar(31)
        write(MHH2HDMC,*) thdmcpar(32)
        if (thdmcpar(33).gt.0.d0) then
        write(cosba,*)    dsqrt(1-thdmcpar(33)**2)
        else
        write(cosba,*)    -dsqrt(1-thdmcpar(33)**2)
        end if
        write(z4,*)       thdmcpar(34)
        write(z5,*)       thdmcpar(35)
        write(z7,*)       thdmcpar(36)
        write(tanbeta,*)     thdmcpar(3)
        

        call execute_command_line(trim(thdmcp1)//
     &trim(thdmcp2)//
     &trim(thdmcp3)//
     &"/CalcHybrid"//
     &trim(Mh2HDMC) //
     &trim(MHH2HDMC) // 
     &trim(cosba) //
     &trim(z4) //
     &trim(z5) //
     &trim(z7) //
     &trim(tanbeta) //
     &" 2" //
     &trim(resultname))

        thdmckey = 3
        tparam(1) = thdmcpar(31)
        tparam(2) = thdmcpar(32)
        tparam(3) = thdmcpar(33)
        tparam(5) = thdmcpar(34)
        tparam(6) = thdmcpar(35)
        tparam(7) = thdmcpar(36)
      
! Physical basis      
      
      else if (thdmcpar(21).ne.0) then

        write(Mh2HDMC,*)  thdmcpar(21)
        write(MHH2HDMC,*) thdmcpar(22)
        write(MA2HDMC,*)  thdmcpar(23)
        write(MHP2HDMC,*) thdmcpar(24)
        write(sinba,*)    thdmcpar(25)
        write(lam6,*)     thdmcpar(26)
        write(lam7,*)     thdmcpar(27)
        write(m12,*)      thdmcpar(4)
        write(tanbeta,*)     thdmcpar(3)

        call execute_command_line(trim(thdmcp1)//
     &trim(thdmcp2)//
     &trim(thdmcp3)//
     &"/CalcPhys"//
     &trim(Mh2HDMC) //
     &trim(MHH2HDMC) // 
     &trim(MA2HDMC) //
     &trim(MHp2HDMC) //
     &trim(sinba) //
     &trim(lam6) //
     &trim(lam7) //
     &trim(m12) //
     &trim(tanbeta) //
     &" 2" //
     &trim(resultname))      

        thdmckey = 2
        tparam(1) = thdmcpar(21)
        tparam(2) = thdmcpar(22)
        tparam(3) = thdmcpar(23)
        tparam(4) = thdmcpar(24)
        tparam(5) = thdmcpar(25)
        tparam(6) = thdmcpar(26)
        tparam(7) = thdmcpar(27)
        thdmcm12 = thdmcpar(4)

      endif
      
! concatenate input file and result of 2HDMC to create new input file for sushi
      call execute_command_line("cat "//
     &trim(fsin)//
     &trim(resultname)//" >"//
     &fsout)

     
! delete remainders of procedure after concatenation
      call execute_command_line("rm"//trim(resultname))

! include references     
      citations(25) = 1    

      end

      integer function jc_len(string) !Find string length
      character(*) string
      jl=0                      !blank string returns length 0
      i=len(string)
      do while (i.gt.jl)
         if(ichar(string(i:i)).gt.ichar(' ')) jl=i
         i=i-1
      enddo
      jc_len=jl
      end
      
