! This file is part of SusHi.
!
! It includes the call of FeynHiggs.
!

#include "versions.h"

      subroutine runfeynhiggs(alfasmz,mt,mbmb,mw,mz,mh,pseudo
     &,cAtFH,cAbFH,MUEFH,M_3FH,MglFH,dMLbFH
     &,msb12,msb22,mst12,mst22,cthetabFH,sthetabFH,cthetatFH,sthetatFH)

      implicit none
      integer nmfv, pseudo
      integer count1
      integer count2
      double precision alfasmz,mt,mbmb,mw,mz,mh
      include '../commons/common-inputoutput.f'
      include '../commons/common-ren.f'
      include '../commons/common-consts.f' !Pi
      include '../commons/common-citations.f'
      !FH specific variables
      double precision MCha(2),MNeu(4),MHtree(4)
      double precision MHiggs(4),SAtree,MSt(2),MTrun,MSb(2),SUMbSL2
      double complex UCha(2,2),VCha(2,2),ZNeu(4,4)
      double complex SAeff,UHiggs(3,3),ZHiggs(3,3),USt(2,2),USb(2,2)
      double complex Deltab
      double complex Hmixtree(3,3)
      double precision msb12,msb22,mst12,mst22,AlphasMT
      double precision cthetabFH,sthetabFH,cthetatFH,sthetatFH
      double precision MglFH,dMLbFH
      double complex cAtFH,cAbFH,MUEFH,M_3FH
      character fhvers*20,hbvers*20,hsvers*20,thdmcvers*20
      common /vers/ fhvers,hbvers,hsvers,thdmcvers
      !quadruple precision for FeynHiggs calls
#ifndef FEYNHIGGSQUAD
      integer, parameter :: FHprec = 8
#else
      integer, parameter :: FHprec = 16
      !integer, parameter :: sp = selected_real_kind(6, 37)
      !integer, parameter :: dp = selected_real_kind(15, 307)
      !integer, parameter :: qp = selected_real_kind(33, 4931)
#endif
      real(FHprec) qMHiggs(4),qSAeff
      complex(FHprec) qUHiggs(3,3),qZHiggs(3,3)
      real(FHprec) qSUinvAlfa, qAlfasMZ, qGF
      real(FHprec) qME, qMU, qMD, qMM, qMC, qMS, qML, qmbmb
      real(FHprec) qMW, qMZ
      real(FHprec) qCKMlambda, qCKMA, qCKMrhobar, qCKMetabar
      real(FHprec) qscalefactor,qMT,qtanb,qMA0,qMHp
      real(FHprec) qM3SL,qM3SE,qM3SQ,qM3SU,qM3SD
      real(FHprec) qM2SL,qM2SE,qM2SQ,qM2SU,qM2SD
      real(FHprec) qM1SL,qM1SE,qM1SQ,qM1SU,qM1SD
      complex(FHprec) qMUEFH,qcAtau,qcAtFH,qcAbFH
      complex(FHprec) qcAmu,qcAc,qcAs,qcAe,qcAu,qcAd,qM_1
      complex(FHprec) qM_2,qM_3FH
      real(FHprec) qQtau,qQt,qQb
#ifndef FEYNHIGGS2100
      real(FHprec) qMASf(6,4)
      complex(FHprec) qUASf(6,6,4)
      real(FHprec) qMSf(2,4,3)
      complex(FHprec) qUSf(2,2,4,3)
#else
      real(FHprec) qMASf(6,5)
      complex(FHprec) qUASf(6,6,5)
      real(FHprec) qMSf(2,5,3)
      complex(FHprec) qUSf(2,2,5,3)
#endif
      real(FHprec) qMCha(2)
      real(FHprec) qMNeu(4), qcdelmb, qMGl
      real(FHprec) qMHtree(4), qSAtree, qAlphasMT
      complex(FHprec) qZNeu(4,4), qUCha(2,2), qVCha(2,2)
      real(FHprec) qMSt(2),qMTrun,qMSb(2),qSUMbSL2
      complex(FHprec) qUSt(2,2),qUSb(2,2),qDeltab

#ifndef FEYNHIGGS2100
      double precision MASf(6,4)
      double complex UASf(6,6,4)
      double precision MSf(2,4,3)
      double complex USf(2,2,4,3)
!extension of mass matrices and vectors in FH 2.10.0
#else
      double precision MASf(6,5)
      double complex UASf(6,6,5)
      double precision MSf(2,5,3)
      double complex USf(2,2,5,3)
#endif
!setting variables from double to potential quadruple precision:
      qSUinvAlfa = real(SUinvAlfa,FHprec)
      qAlfasMZ = real(AlfasMZ,FHprec)
      qGF = real(GF,FHprec)
      qME = real(ME,FHprec)
      qMU = real(MU,FHprec)
      qMD = real(MD,FHprec)
      qMM = real(MM,FHprec)
      qMC = real(MC,FHprec)
      qMS = real(MS,FHprec)
      qML = real(ML,FHprec)
      qmbmb = real(mbmb,FHprec)
      qMW = real(MW,FHprec)
      qMZ = real(MZ,FHprec)
      qCKMlambda = real(CKMlambda,FHprec)
      qCKMA = real(CKMA,FHprec)
      qCKMrhobar = real(CKMrhobar,FHprec)
      qCKMetabar = real(CKMetabar,FHprec)
      qscalefactor = real(scalefactor,FHprec)
      qMT = real(MT,FHprec)
      qtanb = real(tanb,FHprec)
      qMA0 = real(MA0,FHprec)
      qMHp = real(MHp,FHprec)
      qM3SL = real(M3SL,FHprec)
      qM3SE = real(M3SE,FHprec)
      qM3SQ = real(M3SQ,FHprec)
      qM3SU = real(M3SU,FHprec)
      qM3SD = real(M3SD,FHprec)
      qM2SL = real(M2SL,FHprec)
      qM2SE = real(M2SE,FHprec)
      qM2SQ = real(M2SQ,FHprec)
      qM2SU = real(M2SU,FHprec)
      qM2SD = real(M2SD,FHprec)
      qM1SL = real(M1SL,FHprec)
      qM1SE = real(M1SE,FHprec)
      qM1SQ = real(M1SQ,FHprec)
      qM1SU = real(M1SU,FHprec)
      qM1SD = real(M1SD,FHprec)
      qMUEFH = MUEFH
      qcAtau = cAtau
      qcAtFH = cAtFH
      qcAbFH = cAbFH
      qcAmu = cAmu
      qcAc = cAc
      qcAs = cAs
      qcAe = cAe
      qcAu = cAu
      qcAd = cAd
      qM_1 = M_1
      qM_2 = M_2
      qM_3FH = M_3FH
      qQtau = real(Qtau,FHprec)
      qQt = real(Qt,FHprec)
      qQb = real(Qb,FHprec)

!#include "HBandHSwithFH.h"
!#include "FHCouplings.h"
!        double complex couplings(ncouplings), couplingsms(ncouplingsms)
!        double precision gammas(ngammas), gammasms(ngammasms)
!       integer fast
!#include "FHCouplings.h"
!	double complex couplings(ncouplings), couplingsms(ncouplingsms)
!	double precision gammas(ngammas), gammasms(ngammasms)
!	integer fast


#ifdef HIGGSBOUNDS
#include "HBandHSwithFH.h"
      citations(31) = 1
      citations(32) = 1
      citations(33) = 1
#endif

      fhvers = FHVERSION
      hbvers = HBVERSION
      hsvers = HSVERSION

      error = 0
#ifndef FEYNHIGGS2120
      call FHSetFlags(error,
     &     mssmpart, fieldren, tanbren, higgsmix, p2approx,
     &     looplevel, runningMT, botResum, tlCplxApprox)
#else
#ifndef FEYNHIGGS2140
      call FHSetFlags(error,
     &     mssmpart, fieldren, tanbren, higgsmix, p2approx,
     &     looplevel, loglevel, runningMT, botResum, tlCplxApprox)
#else
      call FHSetFlags(error,
     &     mssmpart, higgsmix, p2approx,
     &     looplevel, loglevel, runningMT, botResum, tlCplxApprox)
#endif
#endif

      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHSetFlags ', error
         write(*,105)
         stop
      endif

      !to avoid a wrong setting of alpha_EM in the SusHi to FeynHiggs
      !link FH is asked to use its default value - changed 1.6.0, 27.03.2015
      !Therefore appears a -1 in FHSetSMPara.
      !However note that invAlfaMZ has no effect on the masses calculations in FH!
      !changed back to SUinvAlfa to avoid trouble in the calculation of BR's - 24.06.2017
#ifndef FEYNHIGGS2130
      call FHSetSMPara(error,
     &     qSUinvAlfa, qAlfasMZ, qGF,
     &     qME, qMU, qMD, qMM, qMC, qMS, qML, qmbmb,
     &     qMW, qMZ,
     &     qCKMlambda, qCKMA, qCKMrhobar, qCKMetabar)
#else
      call FHSetSMPara(error,
     &     -1.q0,qSUinvAlfa, qAlfasMZ, qGF,
     &     qME, qMU, qMD, qMM, qMC, qMS, qML, qmbmb,
     &     qMW, qMZ, -1.q0, -1.q0,
     &     qCKMlambda, qCKMA, qCKMrhobar, qCKMetabar)
#endif

      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHSetSMPara ', error
         write(*,105)
         stop
      endif

      call FHSetPara(error,qscalefactor,qMT,qtanb,qMA0,qMHp,
     &     qM3SL,qM3SE,qM3SQ,qM3SU,qM3SD,
     &     qM2SL,qM2SE,qM2SQ,qM2SU,qM2SD,
     &     qM1SL,qM1SE,qM1SQ,qM1SU,qM1SD,
     &     qMUEFH,qcAtau,qcAtFH,qcAbFH,
     &     qcAmu,qcAc,qcAs,qcAe,qcAu,qcAd,
     &     qM_1,qM_2,qM_3FH,qQtau,qQt,qQb)

      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHSetPara ', error
         write(*,105)
         stop
      endif


#ifndef FEYNHIGGS295
      call FHGetPara(error, nmfv, qMASf, qUASf,
     &     qMCha, qUCha, qVCha, qMNeu, qZNeu, qcdelmb, qMGl,
     &     qMHtree, qSAtree)
#else
#ifndef FEYNHIGGS2130
      call FHGetPara(error, nmfv, qMSf, qUSf, qMASf, qUASf,
     &     qMCha, qUCha, qVCha, qMNeu, qZNeu, qcdelmb, qMGl,
     &     qMHtree, qSAtree)
#else
      call FHGetPara(error, nmfv, qMSf, qUSf, qMASf, qUASf,
     &     qMCha, qUCha, qVCha, qMNeu, qZNeu, qcdelmb, qMGl,
     &     qMHtree, qSAtree, qAlphasMT)
#endif
#endif

      MASf = qMASf
      UASf = qUASf
      MSf = qMSf
      USf = qUSf
      MCha = qMCha
      UCha = qUCha
      VCha = qVCha
      MNeu = qMNeu
      ZNeu = qZNeu
      cdelmb = qcdelmb
      MGl = qMGl
      MHtree = qMHtree
      SAtree = qSAtree
      AlphasMT = qAlphasMT

      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHGetPara ', error
         write(*,105)
         stop
      endif

      call FHHiggsCorr(error,qMHiggs,qSAeff,qUHiggs,qZHiggs)

      MHiggs = qMHiggs
      SAeff = qSAeff
      UHiggs = qUHiggs
      ZHiggs = qZHiggs

      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHHiggsCorr ', error
         write(*,105)
         stop
      endif

#ifndef FEYNHIGGS2113
      call FHGetTLPara(error,qMSb,qUSb,qSUMbSL2,qDeltab)
#else
      call FHGetTLPara(error,qMSt,qUSt,qMTrun,qMSb,qUSb,
     &     qSUMbSL2,qDeltab)
#endif

      MSt = qMSt
      MTrun = qMTrun
      MSb = qMSb
      SUMbSL2 = qSUMbSL2
      USt = qUSt
      USb = qUsb
      Deltab = qDeltab

      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHGetTLPara ', error
         write(*,105)
         stop
      endif

#ifdef HIGGSBOUNDS
!Call HiggsBounds and HiggsSignals
#include "HBandHSwithFH.F"
#endif

      dMLbFH = SUMbSL2-M3SQ**2

!Set delmb equal to cdelmb from FH - own calculation in renscheme.f
      delmb = Real(cdelmb)
!Using a cheap trick to have 1/|1+Delta_b|
      delmb = Abs(1.d0 + cdelmb) - 1.d0

      msb12 = Msb(1)**2
      msb22 = Msb(2)**2

      cthetabFH = Real(Usb(1,1))
      sthetabFH = Real(Usb(1,2))

!      write(*,*) 'mbsb',dsqrt(cthetabFH**2 * msb12 + sthetabFH**2 *msb22
!     &  - dMLbFH - M3SQ**2 - MZ**2 * dcos(2.d0*datan(tanb))
!     & * (-1/2.d0+1/3.d0*0.47185299816226306**2))

      RD11 = Usb(1,1)
      RD12 = Usb(1,2)
      RD21 = Usb(2,1)
      RD22 = Usb(2,2)

      !only real MSSM implemented, SAeff expected to be real
      alpha = dasin(Real(SAeff))
!      write(*,*) 'SAeff vs SAtree', SAeff, SAtree
      mst12 = MASf(3,3)**2
      mst22 = MASf(6,3)**2
      cthetatFH = Real(UASf(3,3,3))
      sthetatFH = Real(UASf(3,6,3))
!      muSUSY = Real(MUEFH)

      Hmx = 0.d0
      Hmx(1,1) = -Real(SAeff)
      Hmx(1,2) = dsqrt(1.d0-Real(SAeff)*Real(SAeff))
      Hmx(2,1) = dsqrt(1.d0-Real(SAeff)*Real(SAeff))
      Hmx(2,2) = Real(SAeff)

      Amx = 0.d0
      Amx(2,2) = 1.d0
      
      !treatment in the complex MSSM (and real MSSM using ZHiggs)
      Hmixtree = DCMPLX(0.d0,0.d0)
      Hmixtree(1,1) = DCMPLX(-SAtree,0.d0)
      Hmixtree(1,2) = DCMPLX(dsqrt(1.d0-SAtree*SAtree),0.d0)
      Hmixtree(2,1) = DCMPLX(dsqrt(1.d0-SAtree*SAtree),0.d0)
      Hmixtree(2,2) = DCMPLX(SAtree,0.d0)
      Hmixtree(3,3) = DCMPLX(1.d0,0.d0) !pseudoscalar component
      CHmx = Matmul(ZHiggs,Hmixtree)

      if ((model.eq.1).and.(ZHiggsapply.eq.0)) then
      do count1=1,3
      do count2=1,3
      CHmx(count1,count2) = DCMPLX(Hmx(count1,count2),0.d0) !use the effective mixing angle for h,H -> Amx for A
      end do
      end do 
      end if
!      do count1=1,3
!      do count2=1,3
!      write(*,*) 'element',count1,count2,Zhiggs(count1,count2)
!      end do
!      end do 
!      write(*,*) '***ZHiggs***',ZHiggs

!thetab from OS-sbottom masses in renormalize()

!      call higgsCoup

      if (pseudo.eq.0) then
       if (Sind.eq.1) then
         Mh = MHiggs(1)         !h
       else if (Sind.eq.2) then
         Mh = MHiggs(2)         !H
       else if (Sind.eq.3) then
         Mh = MHiggs(3)         !for the complex MSSM
       end if
      else if (pseudo.eq.1) then
         Mh = MHiggs(3)         !A
      endif

 105  format('#--------------------------------------------------#')

      end

!routine for calculating branching ratios and interference factors
!for now it only works for an interference among the two heavy Higgses
      subroutine runFHBRandINT(alfasmz,mt,mbmb,mw,mz
     &,cAtFH,cAbFH,MUEFH,M_3FH,etaA,BRA)

      implicit none
      integer nmfv
      integer count1, count2, count3
      double precision alfasmz,mt,mbmb,mw,mz
      include '../commons/common-inputoutput.f'
      include '../commons/common-ren.f'
      include '../commons/common-consts.f' !Pi
      include '../commons/common-citations.f'
      include '../commons/common-bwbw.f'
      !FH specific variables
      double precision MCha(2),MNeu(4),MHtree(4)
      double precision MHiggs(4),SAtree,MSt(2),MTrun,MSb(2),SUMbSL2
      double complex UCha(2,2),VCha(2,2),ZNeu(4,4)
      double complex SAeff,UHiggs(3,3),ZHiggs(3,3),USt(2,2),USb(2,2)
      double complex Deltab
      double complex Hmixtree(3,3)
      double precision AlphasMT
      double complex cAtFH,cAbFH,MUEFH,M_3FH
      character fhvers*20,hbvers*20,hsvers*20,thdmcvers*20
      integer mfeff,uzint,uzext
      common /vers/ fhvers,hbvers,hsvers,thdmcvers
#ifndef FEYNHIGGS2100
      double precision MASf(6,4)
      double complex UASf(6,6,4)
      double precision MSf(2,4,3)
      double complex USf(2,2,4,3)
!extension of mass matrices and vectors in FH 2.10.0
#else
      double precision MASf(6,5)
      double complex UASf(6,6,5)
      double precision MSf(2,5,3)
      double complex USf(2,2,5,3)
#endif
!parameters for quadruple precision
#ifndef FEYNHIGGSQUAD
      integer, parameter :: FHprec = 8
#else
      integer, parameter :: FHprec = 16
      !integer, parameter :: sp = selected_real_kind(6, 37)
      !integer, parameter :: dp = selected_real_kind(15, 307)
      !integer, parameter :: qp = selected_real_kind(33, 4931)
#endif
      real(FHprec) qMHiggs(4),qSAeff
      complex(FHprec) qUHiggs(3,3),qZHiggs(3,3)
      real(FHprec) qSUinvAlfa, qAlfasMZ, qGF
      real(FHprec) qME, qMU, qMD, qMM, qMC, qMS, qML, qmbmb
      real(FHprec) qMW, qMZ
      real(FHprec) qCKMlambda, qCKMA, qCKMrhobar, qCKMetabar
      real(FHprec) qscalefactor,qMT,qtanb,qMA0,qMHp
      real(FHprec) qM3SL,qM3SE,qM3SQ,qM3SU,qM3SD
      real(FHprec) qM2SL,qM2SE,qM2SQ,qM2SU,qM2SD
      real(FHprec) qM1SL,qM1SE,qM1SQ,qM1SU,qM1SD
      complex(FHprec) qMUEFH,qcAtau,qcAtFH,qcAbFH
      complex(FHprec) qcAmu,qcAc,qcAs,qcAe,qcAu,qcAd,qM_1
      complex(FHprec) qM_2,qM_3FH
      real(FHprec) qQtau,qQt,qQb
#ifndef FEYNHIGGS2100
      real(FHprec) qMASf(6,4)
      complex(FHprec) qUASf(6,6,4)
      real(FHprec) qMSf(2,4,3)
      complex(FHprec) qUSf(2,2,4,3)
#else
      real(FHprec) qMASf(6,5)
      complex(FHprec) qUASf(6,6,5)
      real(FHprec) qMSf(2,5,3)
      complex(FHprec) qUSf(2,2,5,3)
#endif
      real(FHprec) qMCha(2)
      real(FHprec) qMNeu(4), qcdelmb, qMGl
      real(FHprec) qMHtree(4), qSAtree, qAlphasMT
      complex(FHprec) qZNeu(4,4), qUCha(2,2), qVCha(2,2)
      real(FHprec) qMSt(2),qMTrun,qMSb(2),qSUMbSL2
      complex(FHprec) qUSt(2,2),qUSb(2,2),qDeltab

#include "FHCouplings.h"
      double complex couplings(ncouplings), couplingsms(ncouplingsms)
      double precision gammas(ngammas), gammasms(ngammasms)
      integer fast

      complex(FHprec) qcouplings(ncouplings), qcouplingsms(ncouplingsms)
      real(FHprec) qgammas(ngammas), qgammasms(ngammasms)

!relevant for the calculation of interference factors:
      double precision SB, CB, CB2, SB2, TB2, C2B, S2B
      double precision SA, CA2, SA2, C2A, S2A
      double precision CBA, SBA, CBA2, SBA2
      double precision S2AB, S2BA, C2AB, C2BA, aSUSY, bSUSY
      double precision p2, A2(3,3)
      double precision wbb(3,3), wgg(3,3)
      double complex BW(3), MHc(3)
      double precision sqrts, prodxs(nprodxs)
      double precision etaA(2,8), BRA(8)
      double precision chi2, BWBWout, BWBWouterr
      double complex CouS(4,2)

!vegas integration:
      double precision acc1,xl,xu
      integer ndim,ncall,itmx,nprn
      common/BVEG1/xl(10),xu(10),acc1,ndim,ncall,itmx,nprn
      external BWBWbbtoff, BWBWggtoff

      fhvers = FHVERSION

!setting variables from double to potential quadruple precision:
      qSUinvAlfa = real(SUinvAlfa,FHprec)
      qAlfasMZ = real(AlfasMZ,FHprec)
      qGF = real(GF,FHprec)
      qME = real(ME,FHprec)
      qMU = real(MU,FHprec)
      qMD = real(MD,FHprec)
      qMM = real(MM,FHprec)
      qMC = real(MC,FHprec)
      qMS = real(MS,FHprec)
      qML = real(ML,FHprec)
      qmbmb = real(mbmb,FHprec)
      qMW = real(MW,FHprec)
      qMZ = real(MZ,FHprec)
      qCKMlambda = real(CKMlambda,FHprec)
      qCKMA = real(CKMA,FHprec)
      qCKMrhobar = real(CKMrhobar,FHprec)
      qCKMetabar = real(CKMetabar,FHprec)
      qscalefactor = real(scalefactor,FHprec)
      qMT = real(MT,FHprec)
      qtanb = real(tanb,FHprec)
      qMA0 = real(MA0,FHprec)
      qMHp = real(MHp,FHprec)
      qM3SL = real(M3SL,FHprec)
      qM3SE = real(M3SE,FHprec)
      qM3SQ = real(M3SQ,FHprec)
      qM3SU = real(M3SU,FHprec)
      qM3SD = real(M3SD,FHprec)
      qM2SL = real(M2SL,FHprec)
      qM2SE = real(M2SE,FHprec)
      qM2SQ = real(M2SQ,FHprec)
      qM2SU = real(M2SU,FHprec)
      qM2SD = real(M2SD,FHprec)
      qM1SL = real(M1SL,FHprec)
      qM1SE = real(M1SE,FHprec)
      qM1SQ = real(M1SQ,FHprec)
      qM1SU = real(M1SU,FHprec)
      qM1SD = real(M1SD,FHprec)
      qMUEFH = MUEFH
      qcAtau = cAtau
      qcAtFH = cAtFH
      qcAbFH = cAbFH
      qcAmu = cAmu
      qcAc = cAc
      qcAs = cAs
      qcAe = cAe
      qcAu = cAu
      qcAd = cAd
      qM_1 = M_1
      qM_2 = M_2
      qM_3FH = M_3FH
      qQtau = real(Qtau,FHprec)
      qQt = real(Qt,FHprec)
      qQb = real(Qb,FHprec)

      write(*,105)
      write(*,*) 
     &"Branching ratios and interference factors"
      write(*,105)

      error = 0
#ifndef FEYNHIGGS2120
      call FHSetFlags(error,
     &     mssmpart, fieldren, tanbren, higgsmix, p2approx,
     &     looplevel, runningMT, botResum, tlCplxApprox)
#else
#ifndef FEYNHIGGS2140
      call FHSetFlags(error,
     &     mssmpart, fieldren, tanbren, higgsmix, p2approx,
     &     looplevel, loglevel, runningMT, botResum, tlCplxApprox)
#else
      call FHSetFlags(error,
     &     mssmpart, higgsmix, p2approx,
     &     looplevel, loglevel, runningMT, botResum, tlCplxApprox)
#endif
#endif

      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHSetFlags ', error
         write(*,105)
         stop
      endif

      !to avoid a wrong setting of alpha_EM in the SusHi to FeynHiggs
      !link FH is asked to use its default value - changed 1.6.0, 27.03.2015
      !Therefore appears a -1 in FHSetSMPara.
      !However note that invAlfaMZ has no effect on the masses calculations in FH!
      !changed back to SUinvAlfa to avoid trouble in the calculation of BR's - 24.06.2017
#ifndef FEYNHIGGS2130
      call FHSetSMPara(error,
     &     qSUinvAlfa, qAlfasMZ, qGF,
     &     qME, qMU, qMD, qMM, qMC, qMS, qML, qmbmb,
     &     qMW, qMZ,
     &     qCKMlambda, qCKMA, qCKMrhobar, qCKMetabar)
#else
      call FHSetSMPara(error,
     &     137.036q0,qSUinvAlfa, qAlfasMZ, qGF,
     &     qME, qMU, qMD, qMM, qMC, qMS, qML, qmbmb,
     &     qMW, qMZ, -1.q0, -1.q0,
     &     qCKMlambda, qCKMA, qCKMrhobar, qCKMetabar)
#endif

      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHSetSMPara ', error
         write(*,105)
         stop
      endif

      call FHSetPara(error,qscalefactor,qMT,qtanb,qMA0,qMHp,
     &     qM3SL,qM3SE,qM3SQ,qM3SU,qM3SD,
     &     qM2SL,qM2SE,qM2SQ,qM2SU,qM2SD,
     &     qM1SL,qM1SE,qM1SQ,qM1SU,qM1SD,
     &     qMUEFH,qcAtau,qcAtFH,qcAbFH,
     &     qcAmu,qcAc,qcAs,qcAe,qcAu,qcAd,
     &     qM_1,qM_2,qM_3FH,qQtau,qQt,qQb)

      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHSetPara ', error
         write(*,105)
         stop
      endif

#ifndef FEYNHIGGS295
      call FHGetPara(error, nmfv, qMASf, qUASf,
     &     qMCha, qUCha, qVCha, qMNeu, qZNeu, qcdelmb, qMGl,
     &     qMHtree, qSAtree)
#else
#ifndef FEYNHIGGS2130
      call FHGetPara(error, nmfv, qMSf, qUSf, qMASf, qUASf,
     &     qMCha, qUCha, qVCha, qMNeu, qZNeu, qcdelmb, qMGl,
     &     qMHtree, qSAtree)
#else
      call FHGetPara(error, nmfv, qMSf, qUSf, qMASf, qUASf,
     &     qMCha, qUCha, qVCha, qMNeu, qZNeu, qcdelmb, qMGl,
     &     qMHtree, qSAtree, qAlphasMT)
#endif
#endif

      MASf = qMASf
      UASf = qUASf
      MSf = qMSf
      USf = qUSf
      MCha = qMCha
      UCha = qUCha
      VCha = qVCha
      MNeu = qMNeu
      ZNeu = qZNeu
      cdelmb = qcdelmb
      MGl = qMGl
      MHtree = qMHtree
      SAtree = qSAtree
      AlphasMT = qAlphasMT

      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHGetPara ', error
         write(*,105)
         stop
      endif

      SA  = SAtree
      SA2 = SA**2
      CA2 = 1.d0-SA2
      CA  = dsqrt(1.d0-SA2)
! trigonometry below: from FormCalc/model_cMhmod.F
      TB2 = tanb**2
      CB2 = 1.d0/(1.d0 + TB2)
      SB2 = CB2*TB2
      CB = dsqrt(CB2)
      SB = CB*tanb
      S2B = 2.d0*tanb*CB2
      C2B = (CB - SB)*(CB + SB)

      call FHHiggsCorr(error,qMHiggs,qSAeff,qUHiggs,qZHiggs)

      MHiggs = qMHiggs
      SAeff = qSAeff
      UHiggs = qUHiggs
      ZHiggs = qZHiggs

      if(error.ne.0) then
         write(*,105)
         write(*,*) 'Error in FHHiggsCorr ', error
         write(*,105)
         stop
      endif

      mfeff=1 !default 1 FH 2.13
      uzint=2 !default 1 FH 2.13 !2 uses ZHiggs in the couplings
      uzext=3 !default 3 FH 2.13
      call FHSelectUZ(error, uzint, uzext, mfeff)
      call FHCouplings(error, 
     &     qcouplings, qcouplingsms,
     &     qgammas, qgammasms, fast)

      couplings = qcouplings
      couplingsms = qcouplingsms
      gammas = qgammas
      gammasms = qgammasms

      BRA = 0.d0
      BRA(1) = BR(H0FF(Sind,2,3,3)) !tau tau
      BRA(2) = BR(H0FF(Sind,4,3,3)) !b b~
      BRA(3) = BR(H0FF(Sind,3,3,3)) !t t~
      BRA(4) = BR(H0VV(Sind,1)) !ga ga
      BRA(5) = BR(H0VV(Sind,2)) !W W
      BRA(6) = BR(H0VV(Sind,3)) !Z Z
      BRA(7) = BR(H0VV(Sind,4)) !g g
      BRA(8) = BR(H0HH(Sind,1,1)) !h h

      write(*,*) "Masses:      ",MHiggs(1),MHiggs(2),MHiggs(3)
      write(*,*) "Total widths:",GammaTot(1),GammaTot(2),GammaTot(3)

!      write(*,*) "BR(h1->tautau) = ", BR(H0FF(1,2,3,3))
!      write(*,*) "BR(h1->bb)     = ", BR(H0FF(1,4,3,3))
!      write(*,*) "BR(h1->tt)     = ", BR(H0FF(1,3,3,3))
!      write(*,*) "BR(h2->bb)     = ", BR(H0FF(2,4,3,3))
!      write(*,*) "BR(h2->tautau) = ", BR(H0FF(2,2,3,3))
!      write(*,*) "BR(h2->gaga)   = ", BR(H0VV(2,1))
!      write(*,*) "BR(h2->ZZ)     = ", BR(H0VV(2,3))
!      write(*,*) "C(h2 tau tau)  = ", Coupling(H0FF(2,2,3,3))
!      write(*,*) "G(h2->tau tau) = ", Gamma(H0FF(2,2,3,3))
!      write(*,*) "Gtot(2)        = ", GammaTot(1)
!      write(*,*) "Gtot(2)        = ", GammaTot(2)

      mfeff=1 !default 1 FH 2.13
      uzint=0 !default 1 FH 2.13 !0 gives tree-level mixing
      uzext=3 !default 3 FH 2.13
      call FHSelectUZ(error, uzint, uzext, mfeff)
      call FHCouplings(error, 
     &     qcouplings, qcouplingsms,
     &     qgammas, qgammasms, fast)

      couplings = qcouplings
      couplingsms = qcouplingsms
      gammas = qgammas
      gammasms = qgammasms

!performing a few checks to determine the couplings:
!      write(*,*) 'tau A',1777.03D-3/246.21965d0*tanb
!     & *0.14185028829846316d0/0.14434509999506540 

!      write(*,*) 'tau H',1777.03D-3/246.21965d0
!     & *0.14185028829846316d0/0.14434509999506540 
!     & *CA/CB

!      write(*,*) 'tau h',1777.03D-3/246.21965d0
!     & *0.14185028829846316d0/0.14434509999506540 
!     & *(-SA)/CB

!      write(*,*) 'tau h',1777.03D-3/246.21965d0
!     & *0.14185028829846316d0/0.14434509999506540 
!     & *CA/CB*ZHiggs(1,2)
!     & + 1777.03D-3/246.21965d0
!     & *0.14185028829846316d0/0.14434509999506540 
!     & *(-SA)/CB*ZHiggs(1,1)
!     & + 1777.03D-3/246.21965d0*tanb
!     & *0.14185028829846316d0/0.14434509999506540 
!     & *ZHiggs(1,3)

!      write(*,*) "Cbuild(h1 tau tau)  = ",
!     & Coupling(H0FF(1,2,3,3))*ZHiggs(1,1)
!     & +Coupling(H0FF(2,2,3,3))*ZHiggs(1,2)
!     & +Coupling(H0FF(3,2,3,3))*ZHiggs(1,3)

!      write(*,*) "C(h1 tau tau)  = ", Coupling(H0FF(1,2,3,3))
!     & ,LCoupling(H0FF(1,2,3,3)),RCoupling(H0FF(1,2,3,3))
!      write(*,*) "C(h2 tau tau)  = ", Coupling(H0FF(2,2,3,3))
!     & ,LCoupling(H0FF(2,2,3,3)),RCoupling(H0FF(2,2,3,3))
!      write(*,*) "C(h3 tau tau)  = ", Coupling(H0FF(3,2,3,3))
!     & ,LCoupling(H0FF(3,2,3,3)),RCoupling(H0FF(3,2,3,3))
	
! set p2 for momentum evaluation: average of most degenerate masses
! this is an approximation! 
!! if possible: integrate over p2 as in the rest of SusHi or FormCalc
      p2 = ((MHiggs(2)+MHiggs(3))/2.0)**2
	
! construct Breit Wigner propagators	
      do count1 = 1, 3
       MHc(count1) = CMPLX(0, MHiggs(count1)*GammaTot(count1))
       BW(count1) = CMPLX(0.,1.)/(p2 - MHiggs(count1)**2 +MHc(count1))
      enddo

!      write(*,*) "Z22 = ", ZHiggs(2,2)
!      write(*,*) "Z23 = ", ZHiggs(2,3)
!      write(*,*) "Z32 = ", ZHiggs(3,2)
!      write(*,*) "Z33 = ", ZHiggs(3,3)

! 	A2 is a "squared" amplitude:
!   either Aa Ab* or |Aa|^2, a=1,2,3
!   preliminary implementation: only h2-h3 interference
!   see Eq. 38 of 1705.05757, to be applied to all channels

      A2(2,3) = 2.D0*Real(
     &     (CA2*ZHiggs(2,2)*conjg(ZHiggs(3,2))+
     &     SB2*ZHiggs(2,3)*conjg(ZHiggs(3,3)))**2 *
     &     BW(2)*conjg(BW(3)))

!! squared terms of h2 and h3 (calculated by hand):
      A2(2,2) = Abs(CA2*ZHiggs(2,2)**2+SB2*ZHiggs(2,3)**2)**2
     &    *Abs(BW(2))**2

      A2(3,3) = Abs(CA2*ZHiggs(3,2)**2+SB2*ZHiggs(3,3)**2)**2
     &    *Abs(BW(3))**2

      A2(1,1) = 0
      A2(1,2) = 0
      A2(1,3) = 0
      A2(2,1) = A2(1,2)
      A2(3,1) = A2(1,3)
      A2(3,2) = A2(2,3)

      etaA = 0.d0
      count2 = Sind+1
      count3 = Sind+2
      if(count2.gt.3) count2 = count2-3
      if(count3.gt.3) count3 = count3-3
      etaA(2,1)=A2(Sind,count2)/(A2(Sind,Sind)+A2(count2,count2))
     &  +A2(Sind,count3)/(A2(Sind,Sind)+A2(count3,count3)) !bb->tautau
      write(*,*) "Int. for Higgs ", Sind, " = ", etaA(2,1)
	
!version with numerical integration over p2:
      acc1 = 1.d-8
      ndim = 1 ! number of integration variables
      itmx = 5
      nprn = 0 !for VEGAS output: 10
      ncall = 10000
      xl(1)= 0.d0
      xu(1)= 1.d0

!using the naive formula:
      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(3)
      BWBWfactor = (CA2*ZHiggs(2,2)*conjg(ZHiggs(3,2))+
     &     SB2*ZHiggs(2,3)*conjg(ZHiggs(3,3)))**2
      call vegas(BWBWbbtoff,BWBWout,BWBWouterr,chi2)
      A2(2,3) = 2.d0*BWBWout

      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(2)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(2)
      BWBWfactor = Abs(CA2*ZHiggs(2,2)**2+SB2*ZHiggs(2,3)**2)**2
      call vegas(BWBWbbtoff,BWBWout,BWBWouterr,chi2)
      A2(2,2) = BWBWout

      MBW(1)=MHiggs(3)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(3)
      GBW(2)=GammaTot(3)
      BWBWfactor = Abs(CA2*ZHiggs(3,2)**2+SB2*ZHiggs(3,3)**2)**2
      call vegas(BWBWbbtoff,BWBWout,BWBWouterr,chi2)
      A2(3,3) = BWBWout

      A2(1,1) = 0
      A2(1,2) = 0
      A2(1,3) = 0
      A2(2,1) = A2(1,2)
      A2(3,1) = A2(1,3)
      A2(3,2) = A2(2,3)

      etaA = 0.d0
      count2 = Sind+1
      count3 = Sind+2
      if(count2.gt.3) count2 = count2-3
      if(count3.gt.3) count3 = count3-3
      etaA(2,1)=A2(Sind,count2)/(A2(Sind,Sind)+A2(count2,count2))
     &  +A2(Sind,count3)/(A2(Sind,Sind)+A2(count3,count3)) !bb->tautau
      write(*,*) "Int. for Higgs ", Sind, " = ", etaA(2,1)

!version with numerical integration over p2:
      etaA = 0.d0
!bb -> tautau -- to be extended to all Higgs bosons, now only 2 and 3
      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(3)
      CouS = Cmplx(0.d0,0.d0)
      do count1=1,3
      CouS(1,1)=CouS(1,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(2,1)=CouS(2,1)
     & +LCoupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
      CouS(3,1)=CouS(3,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(4,1)=CouS(4,1)
     & +LCoupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
      CouS(1,2)=CouS(1,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(2,2)=CouS(2,2)
     & +RCoupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
      CouS(3,2)=CouS(3,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(4,2)=CouS(4,2)
     & +RCoupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
      end do
!      do count1=1,3
!      CouS(1,1)=CouS(1,1)
!     & +Coupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
!      CouS(2,1)=CouS(2,1)
!     & +Coupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
!      CouS(3,1)=CouS(3,1)
!     & +Coupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
!      CouS(4,1)=CouS(4,1)
!     & +Coupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
!      end do
!      CouS(1,1)=LCoupling(H0FF(2,4,3,3))
!      CouS(2,1)=LCoupling(H0FF(2,2,3,3))
!      CouS(3,1)=LCoupling(H0FF(3,4,3,3))
!      CouS(4,1)=LCoupling(H0FF(3,2,3,3))
!      CouS(1,2)=RCoupling(H0FF(2,4,3,3))
!      CouS(2,2)=RCoupling(H0FF(2,2,3,3))
!      CouS(3,2)=RCoupling(H0FF(3,4,3,3))
!      CouS(4,2)=RCoupling(H0FF(3,2,3,3))
      BWBWfactor =CouS(1,1)*CouS(2,1)*Conjg(Cous(3,1))*Conjg(Cous(4,1))
     & + CouS(2,1)*CouS(1,2)*Conjg(CouS(4,1))*Conjg(CouS(3,2)) 
     & + CouS(1,1)*CouS(2,2)*Conjg(CouS(3,1))*Conjg(CouS(4,2)) 
     & + CouS(1,2)*CouS(2,2)*Conjg(CouS(3,2))*Conjg(CouS(4,2))
      call vegas(BWBWbbtoff,BWBWout,BWBWouterr,chi2)
      A2(2,3) = 2.d0*BWBWout

      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(2)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(2)
      CouS = Cmplx(0.d0,0.d0)
      do count1=1,3
      CouS(1,1)=CouS(1,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(2,1)=CouS(2,1)
     & +LCoupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
      CouS(3,1)=CouS(3,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(4,1)=CouS(4,1)
     & +LCoupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
      CouS(1,2)=CouS(1,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(2,2)=CouS(2,2)
     & +RCoupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
      CouS(3,2)=CouS(3,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(4,2)=CouS(4,2)
     & +RCoupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
      end do
!      do count1=1,3
!      CouS(1,1)=CouS(1,1)
!     & +Coupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
!      CouS(2,1)=CouS(2,1)
!     & +Coupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
!      CouS(3,1)=CouS(3,1)
!     & +Coupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
!      CouS(4,1)=CouS(4,1)
!     & +Coupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
!      end do
!      CouS(1,1)=LCoupling(H0FF(2,4,3,3))
!      CouS(2,1)=LCoupling(H0FF(2,2,3,3))
!      CouS(3,1)=LCoupling(H0FF(2,4,3,3))
!      CouS(4,1)=LCoupling(H0FF(2,2,3,3))
!      CouS(1,2)=RCoupling(H0FF(2,4,3,3))
!      CouS(2,2)=RCoupling(H0FF(2,2,3,3))
!      CouS(3,2)=RCoupling(H0FF(2,4,3,3))
!      CouS(4,2)=RCoupling(H0FF(2,2,3,3))
      BWBWfactor =CouS(1,1)*CouS(2,1)*Conjg(Cous(3,1))*Conjg(Cous(4,1))
     & + CouS(2,1)*CouS(1,2)*Conjg(CouS(4,1))*Conjg(CouS(3,2)) 
     & + CouS(1,1)*CouS(2,2)*Conjg(CouS(3,1))*Conjg(CouS(4,2)) 
     & + CouS(1,2)*CouS(2,2)*Conjg(CouS(3,2))*Conjg(CouS(4,2))
      call vegas(BWBWbbtoff,BWBWout,BWBWouterr,chi2)
      A2(2,2) = BWBWout

      MBW(1)=MHiggs(3)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(3)
      GBW(2)=GammaTot(3)
      CouS = Cmplx(0.d0,0.d0)
      do count1=1,3
      CouS(1,1)=CouS(1,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(2,1)=CouS(2,1)
     & +LCoupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
      CouS(3,1)=CouS(3,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(4,1)=CouS(4,1)
     & +LCoupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
      CouS(1,2)=CouS(1,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(2,2)=CouS(2,2)
     & +RCoupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
      CouS(3,2)=CouS(3,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(4,2)=CouS(4,2)
     & +RCoupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
      end do
!      do count1=1,3
!      CouS(1,1)=CouS(1,1)
!     & +Coupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
!      CouS(2,1)=CouS(2,1)
!     & +Coupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
!      CouS(3,1)=CouS(3,1)
!     & +Coupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
!      CouS(4,1)=CouS(4,1)
!     & +Coupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
!      end do
!      CouS(1,1)=LCoupling(H0FF(3,4,3,3))
!      CouS(2,1)=LCoupling(H0FF(3,2,3,3))
!      CouS(3,1)=LCoupling(H0FF(3,4,3,3))
!      CouS(4,1)=LCoupling(H0FF(3,2,3,3))
!      CouS(1,2)=RCoupling(H0FF(3,4,3,3))
!      CouS(2,2)=RCoupling(H0FF(3,2,3,3))
!      CouS(3,2)=RCoupling(H0FF(3,4,3,3))
!      CouS(4,2)=RCoupling(H0FF(3,2,3,3))
      BWBWfactor =CouS(1,1)*CouS(2,1)*Conjg(Cous(3,1))*Conjg(Cous(4,1))
     & + CouS(2,1)*CouS(1,2)*Conjg(CouS(4,1))*Conjg(CouS(3,2)) 
     & + CouS(1,1)*CouS(2,2)*Conjg(CouS(3,1))*Conjg(CouS(4,2)) 
     & + CouS(1,2)*CouS(2,2)*Conjg(CouS(3,2))*Conjg(CouS(4,2))
      call vegas(BWBWbbtoff,BWBWout,BWBWouterr,chi2)
      A2(3,3) = BWBWout

      A2(1,1) = 0
      A2(1,2) = 0
      A2(1,3) = 0
      A2(2,1) = A2(1,2)
      A2(3,1) = A2(1,3)
      A2(3,2) = A2(2,3)

      count2 = Sind+1
      count3 = Sind+2
      if(count2.gt.3) count2 = count2-3
      if(count3.gt.3) count3 = count3-3
      etaA(2,1)=A2(Sind,count2)/(A2(Sind,Sind)+A2(count2,count2))
     &  +A2(Sind,count3)/(A2(Sind,Sind)+A2(count3,count3))
      write(*,*) "Int. bb->tautau for Higgs ", Sind, " = ", etaA(2,1)

!bb -> bb
      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(3)
      CouS = Cmplx(0.d0,0.d0)
      do count1=1,3
      CouS(1,1)=CouS(1,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(2,1)=CouS(2,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(3,1)=CouS(3,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(4,1)=CouS(4,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(1,2)=CouS(1,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(2,2)=CouS(2,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(3,2)=CouS(3,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(4,2)=CouS(4,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      end do
      BWBWfactor =CouS(1,1)*CouS(2,1)*Conjg(Cous(3,1))*Conjg(Cous(4,1))
     & + CouS(2,1)*CouS(1,2)*Conjg(CouS(4,1))*Conjg(CouS(3,2)) 
     & + CouS(1,1)*CouS(2,2)*Conjg(CouS(3,1))*Conjg(CouS(4,2)) 
     & + CouS(1,2)*CouS(2,2)*Conjg(CouS(3,2))*Conjg(CouS(4,2))
      call vegas(BWBWbbtoff,BWBWout,BWBWouterr,chi2)
      A2(2,3) = 2.d0*BWBWout

      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(2)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(2)
      CouS = Cmplx(0.d0,0.d0)
      do count1=1,3
      CouS(1,1)=CouS(1,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(2,1)=CouS(2,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(3,1)=CouS(3,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(4,1)=CouS(4,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(1,2)=CouS(1,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(2,2)=CouS(2,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(3,2)=CouS(3,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(4,2)=CouS(4,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      end do
      BWBWfactor =CouS(1,1)*CouS(2,1)*Conjg(Cous(3,1))*Conjg(Cous(4,1))
     & + CouS(2,1)*CouS(1,2)*Conjg(CouS(4,1))*Conjg(CouS(3,2)) 
     & + CouS(1,1)*CouS(2,2)*Conjg(CouS(3,1))*Conjg(CouS(4,2)) 
     & + CouS(1,2)*CouS(2,2)*Conjg(CouS(3,2))*Conjg(CouS(4,2))
      call vegas(BWBWbbtoff,BWBWout,BWBWouterr,chi2)
      A2(2,2) = BWBWout

      MBW(1)=MHiggs(3)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(3)
      GBW(2)=GammaTot(3)
      CouS = Cmplx(0.d0,0.d0)
      do count1=1,3
      CouS(1,1)=CouS(1,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(2,1)=CouS(2,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(3,1)=CouS(3,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(4,1)=CouS(4,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(1,2)=CouS(1,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(2,2)=CouS(2,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(3,2)=CouS(3,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(4,2)=CouS(4,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      end do
      BWBWfactor =CouS(1,1)*CouS(2,1)*Conjg(Cous(3,1))*Conjg(Cous(4,1))
     & + CouS(2,1)*CouS(1,2)*Conjg(CouS(4,1))*Conjg(CouS(3,2)) 
     & + CouS(1,1)*CouS(2,2)*Conjg(CouS(3,1))*Conjg(CouS(4,2)) 
     & + CouS(1,2)*CouS(2,2)*Conjg(CouS(3,2))*Conjg(CouS(4,2))
      call vegas(BWBWbbtoff,BWBWout,BWBWouterr,chi2)
      A2(3,3) = BWBWout

      A2(1,1) = 0
      A2(1,2) = 0
      A2(1,3) = 0
      A2(2,1) = A2(1,2)
      A2(3,1) = A2(1,3)
      A2(3,2) = A2(2,3)

      count2 = Sind+1
      count3 = Sind+2
      if(count2.gt.3) count2 = count2-3
      if(count3.gt.3) count3 = count3-3
      etaA(2,2)=A2(Sind,count2)/(A2(Sind,Sind)+A2(count2,count2))
     &  +A2(Sind,count3)/(A2(Sind,Sind)+A2(count3,count3))
      write(*,*) "Int. bb->bb for Higgs ", Sind, " = ", etaA(2,2)

!bb -> tt
      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(3)
      CouS = Cmplx(0.d0,0.d0)
      do count1=1,3
      CouS(1,1)=CouS(1,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(2,1)=CouS(2,1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CouS(3,1)=CouS(3,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(4,1)=CouS(4,1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CouS(1,2)=CouS(1,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(2,2)=CouS(2,2)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CouS(3,2)=CouS(3,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(4,2)=CouS(4,2)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      end do
      BWBWfactor =CouS(1,1)*CouS(2,1)*Conjg(Cous(3,1))*Conjg(Cous(4,1))
     & + CouS(2,1)*CouS(1,2)*Conjg(CouS(4,1))*Conjg(CouS(3,2)) 
     & + CouS(1,1)*CouS(2,2)*Conjg(CouS(3,1))*Conjg(CouS(4,2)) 
     & + CouS(1,2)*CouS(2,2)*Conjg(CouS(3,2))*Conjg(CouS(4,2))
      call vegas(BWBWbbtoff,BWBWout,BWBWouterr,chi2)
      A2(2,3) = 2.d0*BWBWout

      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(2)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(2)
      CouS = Cmplx(0.d0,0.d0)
      do count1=1,3
      CouS(1,1)=CouS(1,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(2,1)=CouS(2,1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CouS(3,1)=CouS(3,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(4,1)=CouS(4,1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CouS(1,2)=CouS(1,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(2,2)=CouS(2,2)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CouS(3,2)=CouS(3,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CouS(4,2)=CouS(4,2)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      end do
      BWBWfactor =CouS(1,1)*CouS(2,1)*Conjg(Cous(3,1))*Conjg(Cous(4,1))
     & + CouS(2,1)*CouS(1,2)*Conjg(CouS(4,1))*Conjg(CouS(3,2)) 
     & + CouS(1,1)*CouS(2,2)*Conjg(CouS(3,1))*Conjg(CouS(4,2)) 
     & + CouS(1,2)*CouS(2,2)*Conjg(CouS(3,2))*Conjg(CouS(4,2))
      call vegas(BWBWbbtoff,BWBWout,BWBWouterr,chi2)
      A2(2,2) = BWBWout

      MBW(1)=MHiggs(3)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(3)
      GBW(2)=GammaTot(3)
      CouS = Cmplx(0.d0,0.d0)
      do count1=1,3
      CouS(1,1)=CouS(1,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(2,1)=CouS(2,1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CouS(3,1)=CouS(3,1)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(4,1)=CouS(4,1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CouS(1,2)=CouS(1,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(2,2)=CouS(2,2)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CouS(3,2)=CouS(3,2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CouS(4,2)=CouS(4,2)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      end do
      BWBWfactor =CouS(1,1)*CouS(2,1)*Conjg(Cous(3,1))*Conjg(Cous(4,1))
     & + CouS(2,1)*CouS(1,2)*Conjg(CouS(4,1))*Conjg(CouS(3,2)) 
     & + CouS(1,1)*CouS(2,2)*Conjg(CouS(3,1))*Conjg(CouS(4,2)) 
     & + CouS(1,2)*CouS(2,2)*Conjg(CouS(3,2))*Conjg(CouS(4,2))
      call vegas(BWBWbbtoff,BWBWout,BWBWouterr,chi2)
      A2(3,3) = BWBWout

      A2(1,1) = 0
      A2(1,2) = 0
      A2(1,3) = 0
      A2(2,1) = A2(1,2)
      A2(3,1) = A2(1,3)
      A2(3,2) = A2(2,3)

      count2 = Sind+1
      count3 = Sind+2
      if(count2.gt.3) count2 = count2-3
      if(count3.gt.3) count3 = count3-3
      etaA(2,3)=A2(Sind,count2)/(A2(Sind,Sind)+A2(count2,count2))
     &  +A2(Sind,count3)/(A2(Sind,Sind)+A2(count3,count3))
      write(*,*) "Int. bb->tt for Higgs ", Sind, " = ", etaA(2,3)

!gg -> tautau
      MT2=MT**2
      MB2=mbmb**2
      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(3)
      CSL = Cmplx(0.d0,0.d0)
      CSR = Cmplx(0.d0,0.d0)
      do count1=1,3
      CSL(1)=CSL(1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSR(1)=CSR(1)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSL(2)=CSL(2)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSR(2)=CSR(2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSL(3)=CSL(3)
     & +LCoupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
      CSR(3)=CSR(3)
     & +RCoupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
      CSL(4)=CSL(4)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSR(4)=CSR(4)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSL(5)=CSL(5)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSR(5)=CSR(5)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSL(6)=CSL(6)
     & +LCoupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
      CSR(6)=CSR(6)
     & +RCoupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
      end do
      call vegas(BWBWggtoff,BWBWout,BWBWouterr,chi2)
      A2(2,3) = 2.d0*BWBWout

      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(2)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(2)
      CSL = Cmplx(0.d0,0.d0)
      CSR = Cmplx(0.d0,0.d0)
      do count1=1,3
      CSL(1)=CSL(1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSR(1)=CSR(1)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSL(2)=CSL(2)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSR(2)=CSR(2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSL(3)=CSL(3)
     & +LCoupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
      CSR(3)=CSR(3)
     & +RCoupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
      CSL(4)=CSL(4)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSR(4)=CSR(4)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSL(5)=CSL(5)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSR(5)=CSR(5)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSL(6)=CSL(6)
     & +LCoupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
      CSR(6)=CSR(6)
     & +RCoupling(H0FF(count1,2,3,3))*ZHiggs(2,count1)
      end do
      call vegas(BWBWggtoff,BWBWout,BWBWouterr,chi2)
      A2(2,2) = BWBWout

      MBW(1)=MHiggs(3)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(3)
      GBW(2)=GammaTot(3)
      CSL = Cmplx(0.d0,0.d0)
      CSR = Cmplx(0.d0,0.d0)
      do count1=1,3
      CSL(1)=CSL(1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSR(1)=CSR(1)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSL(2)=CSL(2)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSR(2)=CSR(2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSL(3)=CSL(3)
     & +LCoupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
      CSR(3)=CSR(3)
     & +RCoupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
      CSL(4)=CSL(4)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSR(4)=CSR(4)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSL(5)=CSL(5)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSR(5)=CSR(5)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSL(6)=CSL(6)
     & +LCoupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
      CSR(6)=CSR(6)
     & +RCoupling(H0FF(count1,2,3,3))*ZHiggs(3,count1)
      end do
      call vegas(BWBWggtoff,BWBWout,BWBWouterr,chi2)
      A2(3,3) = BWBWout

      A2(1,1) = 0
      A2(1,2) = 0
      A2(1,3) = 0
      A2(2,1) = A2(1,2)
      A2(3,1) = A2(1,3)
      A2(3,2) = A2(2,3)

      count2 = Sind+1
      count3 = Sind+2
      if(count2.gt.3) count2 = count2-3
      if(count3.gt.3) count3 = count3-3
      etaA(1,1)=A2(Sind,count2)/(A2(Sind,Sind)+A2(count2,count2))
     &  +A2(Sind,count3)/(A2(Sind,Sind)+A2(count3,count3))
      write(*,*) "Int. gg->tautau for Higgs ", Sind, " = ", etaA(1,1)

!gg -> bb
      MT2=MT**2
      MB2=mbmb**2
      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(3)
      CSL = Cmplx(0.d0,0.d0)
      CSR = Cmplx(0.d0,0.d0)
      do count1=1,3
      CSL(1)=CSL(1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSR(1)=CSR(1)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSL(2)=CSL(2)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSR(2)=CSR(2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSL(3)=CSL(3)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSR(3)=CSR(3)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSL(4)=CSL(4)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSR(4)=CSR(4)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSL(5)=CSL(5)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSR(5)=CSR(5)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSL(6)=CSL(6)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSR(6)=CSR(6)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      end do
      call vegas(BWBWggtoff,BWBWout,BWBWouterr,chi2)
      A2(2,3) = 2.d0*BWBWout

      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(2)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(2)
      CSL = Cmplx(0.d0,0.d0)
      CSR = Cmplx(0.d0,0.d0)
      do count1=1,3
      CSL(1)=CSL(1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSR(1)=CSR(1)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSL(2)=CSL(2)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSR(2)=CSR(2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSL(3)=CSL(3)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSR(3)=CSR(3)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSL(4)=CSL(4)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSR(4)=CSR(4)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSL(5)=CSL(5)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSR(5)=CSR(5)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSL(6)=CSL(6)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSR(6)=CSR(6)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      end do
      call vegas(BWBWggtoff,BWBWout,BWBWouterr,chi2)
      A2(2,2) = BWBWout

      MBW(1)=MHiggs(3)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(3)
      GBW(2)=GammaTot(3)
      CSL = Cmplx(0.d0,0.d0)
      CSR = Cmplx(0.d0,0.d0)
      do count1=1,3
      CSL(1)=CSL(1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSR(1)=CSR(1)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSL(2)=CSL(2)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSR(2)=CSR(2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSL(3)=CSL(3)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSR(3)=CSR(3)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSL(4)=CSL(4)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSR(4)=CSR(4)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSL(5)=CSL(5)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSR(5)=CSR(5)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSL(6)=CSL(6)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSR(6)=CSR(6)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      end do
      call vegas(BWBWggtoff,BWBWout,BWBWouterr,chi2)
      A2(3,3) = BWBWout

      A2(1,1) = 0
      A2(1,2) = 0
      A2(1,3) = 0
      A2(2,1) = A2(1,2)
      A2(3,1) = A2(1,3)
      A2(3,2) = A2(2,3)

      count2 = Sind+1
      count3 = Sind+2
      if(count2.gt.3) count2 = count2-3
      if(count3.gt.3) count3 = count3-3
      etaA(1,2)=A2(Sind,count2)/(A2(Sind,Sind)+A2(count2,count2))
     &  +A2(Sind,count3)/(A2(Sind,Sind)+A2(count3,count3))
      write(*,*) "Int. gg->bb for Higgs ", Sind, " = ", etaA(1,2)

!gg -> tt
      MT2=MT**2
      MB2=mbmb**2
      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(3)
      CSL = Cmplx(0.d0,0.d0)
      CSR = Cmplx(0.d0,0.d0)
      do count1=1,3
      CSL(1)=CSL(1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSR(1)=CSR(1)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSL(2)=CSL(2)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSR(2)=CSR(2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSL(3)=CSL(3)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSR(3)=CSR(3)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSL(4)=CSL(4)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSR(4)=CSR(4)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSL(5)=CSL(5)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSR(5)=CSR(5)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSL(6)=CSL(6)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSR(6)=CSR(6)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      end do
      call vegas(BWBWggtoff,BWBWout,BWBWouterr,chi2)
      A2(2,3) = 2.d0*BWBWout

      MBW(1)=MHiggs(2)
      MBW(2)=MHiggs(2)
      GBW(1)=GammaTot(2)
      GBW(2)=GammaTot(2)
      CSL = Cmplx(0.d0,0.d0)
      CSR = Cmplx(0.d0,0.d0)
      do count1=1,3
      CSL(1)=CSL(1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSR(1)=CSR(1)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSL(2)=CSL(2)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSR(2)=CSR(2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSL(3)=CSL(3)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSR(3)=CSR(3)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSL(4)=CSL(4)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSR(4)=CSR(4)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSL(5)=CSL(5)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSR(5)=CSR(5)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(2,count1)
      CSL(6)=CSL(6)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      CSR(6)=CSR(6)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(2,count1)
      end do
      call vegas(BWBWggtoff,BWBWout,BWBWouterr,chi2)
      A2(2,2) = BWBWout

      MBW(1)=MHiggs(3)
      MBW(2)=MHiggs(3)
      GBW(1)=GammaTot(3)
      GBW(2)=GammaTot(3)
      CSL = Cmplx(0.d0,0.d0)
      CSR = Cmplx(0.d0,0.d0)
      do count1=1,3
      CSL(1)=CSL(1)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSR(1)=CSR(1)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSL(2)=CSL(2)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSR(2)=CSR(2)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSL(3)=CSL(3)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSR(3)=CSR(3)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSL(4)=CSL(4)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSR(4)=CSR(4)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSL(5)=CSL(5)
     & +LCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSR(5)=CSR(5)
     & +RCoupling(H0FF(count1,4,3,3))*ZHiggs(3,count1)
      CSL(6)=CSL(6)
     & +LCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      CSR(6)=CSR(6)
     & +RCoupling(H0FF(count1,3,3,3))*ZHiggs(3,count1)
      end do
      call vegas(BWBWggtoff,BWBWout,BWBWouterr,chi2)
      A2(3,3) = BWBWout

      A2(1,1) = 0
      A2(1,2) = 0
      A2(1,3) = 0
      A2(2,1) = A2(1,2)
      A2(3,1) = A2(1,3)
      A2(3,2) = A2(2,3)

      count2 = Sind+1
      count3 = Sind+2
      if(count2.gt.3) count2 = count2-3
      if(count3.gt.3) count3 = count3-3
      etaA(1,3)=A2(Sind,count2)/(A2(Sind,Sind)+A2(count2,count2))
     &  +A2(Sind,count3)/(A2(Sind,Sind)+A2(count3,count3))
      write(*,*) "Int. gg->tt for Higgs ", Sind, " = ", etaA(1,3)

!      write(*,*) "C(h2 tau tau)  = ", Coupling(H0FF(2,2,3,3))
!     & ,LCoupling(H0FF(2,2,3,3)),RCoupling(H0FF(2,2,3,3))
!      write(*,*) "C(h3 tau tau)  = ", Coupling(H0FF(3,2,3,3))
!     & ,LCoupling(H0FF(3,2,3,3)),RCoupling(H0FF(3,2,3,3))

!      mfeff=1 !default FH 2.13
!      uzint=2 !default FH 2.13
!      uzext=3 !default FH 2.13
!      call FHSelectUZ(error, uzint, uzext, mfeff)
!      call FHCouplings(error, 
!     &     couplings, couplingsms,
!     &     gammas, gammasms, fast)


!      write(*,*) "C(h2 tau tau)  = ", Coupling(H0FF(2,2,3,3))
!     & ,LCoupling(H0FF(2,2,3,3)),RCoupling(H0FF(2,2,3,3))
!	
!      mfeff=1 !default FH 2.13
!      uzint=0 !default FH 2.13
!      uzext=3 !default FH 2.13
!      call FHSelectUZ(error, uzint, uzext, mfeff)
!      call FHCouplings(error, 
!     &     couplings, couplingsms,
!     &     gammas, gammasms, fast)


!      write(*,*) "C(h2 tau tau)  = ", Coupling(H0FF(2,2,3,3))
!     & ,LCoupling(H0FF(2,2,3,3)),RCoupling(H0FF(2,2,3,3))

!      write(*,*) 'ZHiggs',ZHiggs
!      write(*,*) "A2int = ", A2(2,3) 
!      write(*,*) "A2 h2 = ", A2(2,2) 
!      write(*,*) "A2 h3 = ", A2(3,3) 
!      eta = A2(2,3)/(A2(2,2)+A2(3,3))
!      write(*,*) "eta = ", eta
	
c define the weights to split eta into eta1, eta2, eta3	
c w(a,b) = w_ab^P,a defined in Eq. 31 of 1705.05757,
c i.e. the weight of a in the comparison of a,b
c a,b = 1,2,3 for h1, h2, h3
c weights defined for production P via bb or gg
c but so far only bb used

c weights via cross sections: 
c for interference eta based on cross sections
!	sqrts = 13
!	call FHHiggsProd(error, sqrts, prodxs)
! 
! 	do a = 1, 3
! 	  do b = 1, 3
! 	    wbb(a,b) = bbh(a)/(bbh(a)+bbh(b))
! 	    wgg(a,b) = ggh(a)/(ggh(a)+ggh(b))
! 	  enddo
! 	enddo

 105  format('#--------------------------------------------------#')

      end

      double precision function BWBWbbtoff(x)
      !function multiplying two Breit-Wigner propagators
      !x(1) runs from 0 to 1 -> variable transformation needed
      !-> jacobi maps from p to x(1)
      !integration within p = [(M1+M2)/2 +- 5*(G1+G2)/2]
      implicit none
      double precision x(10)
      double precision p2, p, jacobi
      double complex MHc(2),BW(2)
      integer count1
      include '../commons/common-bwbw.f'
      BWBWbbtoff=0.d0

      p = (MBW(1)+MBW(2))/2.0 - (GBW(1)+GBW(2))*5/2
     & + (GBW(1)+GBW(2))*5*x(1)
      p2 = p**2
      jacobi = 5*(GBW(1)+GBW(2)) !normalized to bin width this drops out
	
! construct Breit Wigner propagators	
      do count1 = 1, 2
       MHc(count1) = CMPLX(0, MBW(count1)*GBW(count1))
       BW(count1) = CMPLX(0.,1.)/(p2 - MBW(count1)**2 +MHc(count1))
      enddo

      BWBWbbtoff = Real(BW(1)*conjg(BW(2))*BWBWfactor)

      end

      double complex function C0functionLT(s,mq2)
      !C0 function with arguments (0,s,0,mq2,mq2,mq2)
      implicit none
      double precision s, mq2, tau, beta, Pi
      C0functionLT=(0.d0,1.d0)

      Pi = 3.1415926535897932384626433d0
      tau = 4.d0*mq2/s
      beta = dsqrt(1-tau)
      if (tau.le.1) then
      C0functionLT = 1/s*1/2*(dlog((1+beta)/(1-beta))
     &    -(0.d0,1.d0)*Pi)**2
      end if
      if (tau.gt.1) then
      C0functionLT = -2.d0/s*(ASin(1.d0/dsqrt(tau)))**2
      end if

      end

      double precision function BWBWggtoff(x)
      !matrix element squared of gg to tau tau
      !with two Higgs bosons H and A, both with CL and CR couplings
      !and top and bottom quarks running in the loop
      !-> jacobi maps from p to x(1)
      !integration within p = [(M1+M2)/2 +- 5*(G1+G2)/2]
      implicit none
      double precision x(10)
      double precision S, p, jacobi, MT, MB
      double complex MHc(2),BW(2)
      double complex CCSL(6), CCSR(6), C0functionLT
      double complex C0b,C0t,CC0b,CC0t,ReC0b,ReC0t
      integer count1
      include '../commons/common-bwbw.f'
      BWBWggtoff=0.d0

      p = (MBW(1)+MBW(2))/2.0 - (GBW(1)+GBW(2))*5/2
     & + (GBW(1)+GBW(2))*5*x(1)
      S = p**2
      jacobi = 5*(GBW(1)+GBW(2)) !normalized to bin width this drops out
	
! construct Breit Wigner propagators	
      do count1 = 1, 2
       MHc(count1) = CMPLX(0, MBW(count1)*GBW(count1))
       BW(count1) = CMPLX(0.,1.)/(S - MBW(count1)**2 +MHc(count1))
      enddo

      MT=dsqrt(MT2)
      MB=dsqrt(MB2)
      C0b = C0functionLT(S,MB2)
      C0t = C0functionLT(S,MT2)
      CC0b = Conjg(C0b)
      CC0t = Conjg(C0t)
      ReC0b = (C0b+CC0b)/2.d0
      ReC0t = (C0t+CC0t)/2.d0
      CCSL=Conjg(CSL)
      CCSR=Conjg(CSR)

      BWBWfactor = MT2*S*CCSL(4)*CCSL(6)*CSL(1)*CSL(3)
     & + 4.D0*C0t*CC0t*(MT2*MT2*MT2)*S*CCSL(4)*CCSL(6)*CSL(1)*CSL(3)
     & + 4.D0*MT2*MT2*ReC0t*S*CCSL(4)*CCSL(6)*CSL(1)*CSL(3)
     & + (-2.D0)*C0t*CC0t*(MT2*MT2)*(S*S)*CCSL(4)*CCSL(6)*CSL(1)*CSL(3)
     & + (-1.D0)*MT2*ReC0t*(S*S)*CCSL(4)*CCSL(6)*CSL(1)*CSL(3)
     & + (C0t*CC0t*MT2*(S*S*S)*CCSL(4)*CCSL(6)*CSL(1)*CSL(3))/2.D0
     & + MB*MT*S*CCSL(5)*CCSL(6)*CSL(1)*CSL(3)
     & + 2.D0*CC0b*MB*MB2*MT*S*CCSL(5)*CCSL(6)*CSL(1)*CSL(3)
     & + 2.D0*C0t*MB*MT*MT2*S*CCSL(5)*CCSL(6)*CSL(1)*CSL(3)
     & + 4.D0*C0t*CC0b*MB*MB2*MT*MT2*S*CCSL(5)*CCSL(6)*CSL(1)*CSL(3)
     & + (-1.D0)*C0t*MB*MT*(S*S)*CCSL(5)*CCSL(6)*CSL(1)*CSL(3)/2.D0
     & + (-1.D0)*CC0b*MB*MT*(S*S)*CCSL(5)*CCSL(6)*CSL(1)*CSL(3)/2.D0
     & + (-1.D0)*C0t*CC0b*MB*MB2*MT*(S*S)*CCSL(5)*CCSL(6)*CSL(1)*CSL(3)
     & + (-1.D0)*C0t*CC0b*MB*MT*MT2*(S*S)*CCSL(5)*CCSL(6)*CSL(1)*CSL(3)
     & + (C0t*CC0b*MB*MT*(S*S*S)*CCSL(5)*CCSL(6)*CSL(1)*CSL(3))/2.D0
     & + MT2*S*CCSL(6)*CCSR(4)*CSL(1)*CSL(3)
     & + 4.D0*C0t*CC0t*(MT2*MT2*MT2)*S*CCSL(6)*CCSR(4)*CSL(1)*CSL(3)
     & + 4.D0*MT2*MT2*ReC0t*S*CCSL(6)*CCSR(4)*CSL(1)*CSL(3)
     & + (-2.D0)*C0t*CC0t*(MT2*MT2)*(S*S)*CCSL(6)*CCSR(4)*CSL(1)*CSL(3)
     & + (-1.D0)*MT2*ReC0t*(S*S)*CCSL(6)*CCSR(4)*CSL(1)*CSL(3)
     & + MB*MT*S*CCSL(6)*CCSR(5)*CSL(1)*CSL(3)
     & + 2.D0*CC0b*MB*MB2*MT*S*CCSL(6)*CCSR(5)*CSL(1)*CSL(3)
     & + 2.D0*C0t*MB*MT*MT2*S*CCSL(6)*CCSR(5)*CSL(1)*CSL(3)
     & + 4.D0*C0t*CC0b*MB*MB2*MT*MT2*S*CCSL(6)*CCSR(5)*CSL(1)*CSL(3)
     & + (-1.D0)*C0t*MB*MT*(S*S)*CCSL(6)*CCSR(5)*CSL(1)*CSL(3)/2.D0
     & + (-1.D0)*CC0b*MB*MT*(S*S)*CCSL(6)*CCSR(5)*CSL(1)*CSL(3)/2.D0
     & + (-1.D0)*C0t*CC0b*MB*MB2*MT*(S*S)*CCSL(6)*CCSR(5)*CSL(1)*CSL(3)
     & + (-1.D0)*C0t*CC0b*MB*MT*MT2*(S*S)*CCSL(6)*CCSR(5)*CSL(1)*CSL(3)
     & + MB*MT*S*CCSL(4)*CCSL(6)*CSL(2)*CSL(3)
     & + 2.D0*C0b*MB*MB2*MT*S*CCSL(4)*CCSL(6)*CSL(2)*CSL(3)
     & + 2.D0*CC0t*MB*MT*MT2*S*CCSL(4)*CCSL(6)*CSL(2)*CSL(3)
     & + 4.D0*C0b*CC0t*MB*MB2*MT*MT2*S*CCSL(4)*CCSL(6)*CSL(2)*CSL(3)
     & + (-1.D0)*C0b*MB*MT*(S*S)*CCSL(4)*CCSL(6)*CSL(2)*CSL(3)/2.D0
     & + (-1.D0)*CC0t*MB*MT*(S*S)*CCSL(4)*CCSL(6)*CSL(2)*CSL(3)/2.D0
     & + (-1.D0)*C0b*CC0t*MB*MB2*MT*(S*S)*CCSL(4)*CCSL(6)*CSL(2)*CSL(3)
     & + (-1.D0)*C0b*CC0t*MB*MT*MT2*(S*S)*CCSL(4)*CCSL(6)*CSL(2)*CSL(3)
     & + (C0b*CC0t*MB*MT*(S*S*S)*CCSL(4)*CCSL(6)*CSL(2)*CSL(3))/2.D0
     & + MB2*S*CCSL(5)*CCSL(6)*CSL(2)*CSL(3)
     & + 4.D0*C0b*CC0b*(MB2*MB2*MB2)*S*CCSL(5)*CCSL(6)*CSL(2)*CSL(3)
     & + 4.D0*MB2*MB2*ReC0b*S*CCSL(5)*CCSL(6)*CSL(2)*CSL(3)
     & + (-2.D0)*C0b*CC0b*(MB2*MB2)*(S*S)*CCSL(5)*CCSL(6)*CSL(2)*CSL(3)
     & + (-1.D0)*MB2*ReC0b*(S*S)*CCSL(5)*CCSL(6)*CSL(2)*CSL(3)
     & + (C0b*CC0b*MB2*(S*S*S)*CCSL(5)*CCSL(6)*CSL(2)*CSL(3))/2.D0
     & + MB*MT*S*CCSL(6)*CCSR(4)*CSL(2)*CSL(3)
     & + 2.D0*C0b*MB*MB2*MT*S*CCSL(6)*CCSR(4)*CSL(2)*CSL(3)
     & + 2.D0*CC0t*MB*MT*MT2*S*CCSL(6)*CCSR(4)*CSL(2)*CSL(3)
     & + 4.D0*C0b*CC0t*MB*MB2*MT*MT2*S*CCSL(6)*CCSR(4)*CSL(2)*CSL(3)
     & + (-1.D0)*C0b*MB*MT*(S*S)*CCSL(6)*CCSR(4)*CSL(2)*CSL(3)/2.D0
     & + (-1.D0)*CC0t*MB*MT*(S*S)*CCSL(6)*CCSR(4)*CSL(2)*CSL(3)/2.D0
     & + (-1.D0)*C0b*CC0t*MB*MB2*MT*(S*S)*CCSL(6)*CCSR(4)*CSL(2)*CSL(3)
     & + (-1.D0)*C0b*CC0t*MB*MT*MT2*(S*S)*CCSL(6)*CCSR(4)*CSL(2)*CSL(3)
     & + MB2*S*CCSL(6)*CCSR(5)*CSL(2)*CSL(3)
     & + 4.D0*C0b*CC0b*(MB2*MB2*MB2)*S*CCSL(6)*CCSR(5)*CSL(2)*CSL(3)
     & + 4.D0*MB2*MB2*ReC0b*S*CCSL(6)*CCSR(5)*CSL(2)*CSL(3)
     & + (-2.D0)*C0b*CC0b*(MB2*MB2)*(S*S)*CCSL(6)*CCSR(5)*CSL(2)*CSL(3)
     & + (-1.D0)*MB2*ReC0b*(S*S)*CCSL(6)*CCSR(5)*CSL(2)*CSL(3)
     & + MT2*S*CCSL(4)*CCSL(6)*CSL(3)*CSR(1)
     & + 4.D0*C0t*CC0t*(MT2*MT2*MT2)*S*CCSL(4)*CCSL(6)*CSL(3)*CSR(1)
     & + 4.D0*MT2*MT2*ReC0t*S*CCSL(4)*CCSL(6)*CSL(3)*CSR(1)
     & + (-2.D0)*C0t*CC0t*(MT2*MT2)*(S*S)*CCSL(4)*CCSL(6)*CSL(3)*CSR(1)
     & + (-1.D0)*MT2*ReC0t*(S*S)*CCSL(4)*CCSL(6)*CSL(3)*CSR(1)
     & + MB*MT*S*CCSL(5)*CCSL(6)*CSL(3)*CSR(1)
     & + 2.D0*CC0b*MB*MB2*MT*S*CCSL(5)*CCSL(6)*CSL(3)*CSR(1)
     & + 2.D0*C0t*MB*MT*MT2*S*CCSL(5)*CCSL(6)*CSL(3)*CSR(1)
     & + 4.D0*C0t*CC0b*MB*MB2*MT*MT2*S*CCSL(5)*CCSL(6)*CSL(3)*CSR(1)
     & + (-1.D0)*C0t*MB*MT*(S*S)*CCSL(5)*CCSL(6)*CSL(3)*CSR(1)/2.D0
     & + (-1.D0)*CC0b*MB*MT*(S*S)*CCSL(5)*CCSL(6)*CSL(3)*CSR(1)/2.D0
     & + (-1.D0)*C0t*CC0b*MB*MB2*MT*(S*S)*CCSL(5)*CCSL(6)*CSL(3)*CSR(1)
     & + (-1.D0)*C0t*CC0b*MB*MT*MT2*(S*S)*CCSL(5)*CCSL(6)*CSL(3)*CSR(1)
     & + MT2*S*CCSL(6)*CCSR(4)*CSL(3)*CSR(1)
     & + 4.D0*C0t*CC0t*(MT2*MT2*MT2)*S*CCSL(6)*CCSR(4)*CSL(3)*CSR(1)
     & + 4.D0*MT2*MT2*ReC0t*S*CCSL(6)*CCSR(4)*CSL(3)*CSR(1)
     & + (-2.D0)*C0t*CC0t*(MT2*MT2)*(S*S)*CCSL(6)*CCSR(4)*CSL(3)*CSR(1)
     & + (-1.D0)*MT2*ReC0t*(S*S)*CCSL(6)*CCSR(4)*CSL(3)*CSR(1)
     & + (C0t*CC0t*MT2*(S*S*S)*CCSL(6)*CCSR(4)*CSL(3)*CSR(1))/2.D0
     & + MB*MT*S*CCSL(6)*CCSR(5)*CSL(3)*CSR(1)
     & + 2.D0*CC0b*MB*MB2*MT*S*CCSL(6)*CCSR(5)*CSL(3)*CSR(1)
     & + 2.D0*C0t*MB*MT*MT2*S*CCSL(6)*CCSR(5)*CSL(3)*CSR(1)
     & + 4.D0*C0t*CC0b*MB*MB2*MT*MT2*S*CCSL(6)*CCSR(5)*CSL(3)*CSR(1)
     & + (-1.D0)*C0t*MB*MT*(S*S)*CCSL(6)*CCSR(5)*CSL(3)*CSR(1)/2.D0
     & + (-1.D0)*CC0b*MB*MT*(S*S)*CCSL(6)*CCSR(5)*CSL(3)*CSR(1)/2.D0
     & + (-1.D0)*C0t*CC0b*MB*MB2*MT*(S*S)*CCSL(6)*CCSR(5)*CSL(3)*CSR(1)
     & + (-1.D0)*C0t*CC0b*MB*MT*MT2*(S*S)*CCSL(6)*CCSR(5)*CSL(3)*CSR(1)
     & + (C0t*CC0b*MB*MT*(S*S*S)*CCSL(6)*CCSR(5)*CSL(3)*CSR(1))/2.D0
     & + MB*MT*S*CCSL(4)*CCSL(6)*CSL(3)*CSR(2)
     & + 2.D0*C0b*MB*MB2*MT*S*CCSL(4)*CCSL(6)*CSL(3)*CSR(2)
     & + 2.D0*CC0t*MB*MT*MT2*S*CCSL(4)*CCSL(6)*CSL(3)*CSR(2)
     & + 4.D0*C0b*CC0t*MB*MB2*MT*MT2*S*CCSL(4)*CCSL(6)*CSL(3)*CSR(2)
     & + (-1.D0)*C0b*MB*MT*(S*S)*CCSL(4)*CCSL(6)*CSL(3)*CSR(2)/2.D0
     & + (-1.D0)*CC0t*MB*MT*(S*S)*CCSL(4)*CCSL(6)*CSL(3)*CSR(2)/2.D0
     & + (-1.D0)*C0b*CC0t*MB*MB2*MT*(S*S)*CCSL(4)*CCSL(6)*CSL(3)*CSR(2)
     & + (-1.D0)*C0b*CC0t*MB*MT*MT2*(S*S)*CCSL(4)*CCSL(6)*CSL(3)*CSR(2)
     & + MB2*S*CCSL(5)*CCSL(6)*CSL(3)*CSR(2)
     & + 4.D0*C0b*CC0b*(MB2*MB2*MB2)*S*CCSL(5)*CCSL(6)*CSL(3)*CSR(2)
     & + 4.D0*MB2*MB2*ReC0b*S*CCSL(5)*CCSL(6)*CSL(3)*CSR(2)
     & + (-2.D0)*C0b*CC0b*(MB2*MB2)*(S*S)*CCSL(5)*CCSL(6)*CSL(3)*CSR(2)
     & + (-1.D0)*MB2*ReC0b*(S*S)*CCSL(5)*CCSL(6)*CSL(3)*CSR(2)
     & + MB*MT*S*CCSL(6)*CCSR(4)*CSL(3)*CSR(2)
     & + 2.D0*C0b*MB*MB2*MT*S*CCSL(6)*CCSR(4)*CSL(3)*CSR(2)
     & + 2.D0*CC0t*MB*MT*MT2*S*CCSL(6)*CCSR(4)*CSL(3)*CSR(2)
     & + 4.D0*C0b*CC0t*MB*MB2*MT*MT2*S*CCSL(6)*CCSR(4)*CSL(3)*CSR(2)
     & + (-1.D0)*C0b*MB*MT*(S*S)*CCSL(6)*CCSR(4)*CSL(3)*CSR(2)/2.D0
     & + (-1.D0)*CC0t*MB*MT*(S*S)*CCSL(6)*CCSR(4)*CSL(3)*CSR(2)/2.D0
     & + (-1.D0)*C0b*CC0t*MB*MB2*MT*(S*S)*CCSL(6)*CCSR(4)*CSL(3)*CSR(2)
     & + (-1.D0)*C0b*CC0t*MB*MT*MT2*(S*S)*CCSL(6)*CCSR(4)*CSL(3)*CSR(2)
     & + (C0b*CC0t*MB*MT*(S*S*S)*CCSL(6)*CCSR(4)*CSL(3)*CSR(2))/2.D0
     & + MB2*S*CCSL(6)*CCSR(5)*CSL(3)*CSR(2)
     & + 4.D0*C0b*CC0b*(MB2*MB2*MB2)*S*CCSL(6)*CCSR(5)*CSL(3)*CSR(2)
     & + 4.D0*MB2*MB2*ReC0b*S*CCSL(6)*CCSR(5)*CSL(3)*CSR(2)
     & + (-2.D0)*C0b*CC0b*(MB2*MB2)*(S*S)*CCSL(6)*CCSR(5)*CSL(3)*CSR(2)
     & + (-1.D0)*MB2*ReC0b*(S*S)*CCSL(6)*CCSR(5)*CSL(3)*CSR(2)
     & + (C0b*CC0b*MB2*(S*S*S)*CCSL(6)*CCSR(5)*CSL(3)*CSR(2))/2.D0
     & + MT2*S*CCSL(4)*CCSR(6)*CSL(1)*CSR(3)
     & + 4.D0*C0t*CC0t*(MT2*MT2*MT2)*S*CCSL(4)*CCSR(6)*CSL(1)*CSR(3)
     & + 4.D0*MT2*MT2*ReC0t*S*CCSL(4)*CCSR(6)*CSL(1)*CSR(3)
     & + (-2.D0)*C0t*CC0t*(MT2*MT2)*(S*S)*CCSL(4)*CCSR(6)*CSL(1)*CSR(3)
     & + (-1.D0)*MT2*ReC0t*(S*S)*CCSL(4)*CCSR(6)*CSL(1)*CSR(3)
     & + (C0t*CC0t*MT2*(S*S*S)*CCSL(4)*CCSR(6)*CSL(1)*CSR(3))/2.D0
     & + MB*MT*S*CCSL(5)*CCSR(6)*CSL(1)*CSR(3)
     & + 2.D0*CC0b*MB*MB2*MT*S*CCSL(5)*CCSR(6)*CSL(1)*CSR(3)
     & + 2.D0*C0t*MB*MT*MT2*S*CCSL(5)*CCSR(6)*CSL(1)*CSR(3)
     & + 4.D0*C0t*CC0b*MB*MB2*MT*MT2*S*CCSL(5)*CCSR(6)*CSL(1)*CSR(3)
     & + (-1.D0)*C0t*MB*MT*(S*S)*CCSL(5)*CCSR(6)*CSL(1)*CSR(3)/2.D0
     & + (-1.D0)*CC0b*MB*MT*(S*S)*CCSL(5)*CCSR(6)*CSL(1)*CSR(3)/2.D0
     & + (-1.D0)*C0t*CC0b*MB*MB2*MT*(S*S)*CCSL(5)*CCSR(6)*CSL(1)*CSR(3)
     & + (-1.D0)*C0t*CC0b*MB*MT*MT2*(S*S)*CCSL(5)*CCSR(6)*CSL(1)*CSR(3)
     & + (C0t*CC0b*MB*MT*(S*S*S)*CCSL(5)*CCSR(6)*CSL(1)*CSR(3))/2.D0
     & + MT2*S*CCSR(4)*CCSR(6)*CSL(1)*CSR(3)
     & + 4.D0*C0t*CC0t*(MT2*MT2*MT2)*S*CCSR(4)*CCSR(6)*CSL(1)*CSR(3)
     & + 4.D0*MT2*MT2*ReC0t*S*CCSR(4)*CCSR(6)*CSL(1)*CSR(3)
     & + (-2.D0)*C0t*CC0t*(MT2*MT2)*(S*S)*CCSR(4)*CCSR(6)*CSL(1)*CSR(3)
     & + (-1.D0)*MT2*ReC0t*(S*S)*CCSR(4)*CCSR(6)*CSL(1)*CSR(3)
     & + MB*MT*S*CCSR(5)*CCSR(6)*CSL(1)*CSR(3)
     & + 2.D0*CC0b*MB*MB2*MT*S*CCSR(5)*CCSR(6)*CSL(1)*CSR(3)
     & + 2.D0*C0t*MB*MT*MT2*S*CCSR(5)*CCSR(6)*CSL(1)*CSR(3)
     & + 4.D0*C0t*CC0b*MB*MB2*MT*MT2*S*CCSR(5)*CCSR(6)*CSL(1)*CSR(3)
     & + (-1.D0)*C0t*MB*MT*(S*S)*CCSR(5)*CCSR(6)*CSL(1)*CSR(3)/2.D0
     & + (-1.D0)*CC0b*MB*MT*(S*S)*CCSR(5)*CCSR(6)*CSL(1)*CSR(3)/2.D0
     & + (-1.D0)*C0t*CC0b*MB*MB2*MT*(S*S)*CCSR(5)*CCSR(6)*CSL(1)*CSR(3)
     & + (-1.D0)*C0t*CC0b*MB*MT*MT2*(S*S)*CCSR(5)*CCSR(6)*CSL(1)*CSR(3)
     & + MB*MT*S*CCSL(4)*CCSR(6)*CSL(2)*CSR(3)
     & + 2.D0*C0b*MB*MB2*MT*S*CCSL(4)*CCSR(6)*CSL(2)*CSR(3)
     & + 2.D0*CC0t*MB*MT*MT2*S*CCSL(4)*CCSR(6)*CSL(2)*CSR(3)
     & + 4.D0*C0b*CC0t*MB*MB2*MT*MT2*S*CCSL(4)*CCSR(6)*CSL(2)*CSR(3)
     & + (-1.D0)*C0b*MB*MT*(S*S)*CCSL(4)*CCSR(6)*CSL(2)*CSR(3)/2.D0
     & + (-1.D0)*CC0t*MB*MT*(S*S)*CCSL(4)*CCSR(6)*CSL(2)*CSR(3)/2.D0
     & + (-1.D0)*C0b*CC0t*MB*MB2*MT*(S*S)*CCSL(4)*CCSR(6)*CSL(2)*CSR(3)
     & + (-1.D0)*C0b*CC0t*MB*MT*MT2*(S*S)*CCSL(4)*CCSR(6)*CSL(2)*CSR(3)
     & + (C0b*CC0t*MB*MT*(S*S*S)*CCSL(4)*CCSR(6)*CSL(2)*CSR(3))/2.D0
     & + MB2*S*CCSL(5)*CCSR(6)*CSL(2)*CSR(3)
     & + 4.D0*C0b*CC0b*(MB2*MB2*MB2)*S*CCSL(5)*CCSR(6)*CSL(2)*CSR(3)
     & + 4.D0*MB2*MB2*ReC0b*S*CCSL(5)*CCSR(6)*CSL(2)*CSR(3)
     & + (-2.D0)*C0b*CC0b*(MB2*MB2)*(S*S)*CCSL(5)*CCSR(6)*CSL(2)*CSR(3)
     & + (-1.D0)*MB2*ReC0b*(S*S)*CCSL(5)*CCSR(6)*CSL(2)*CSR(3)
     & + (C0b*CC0b*MB2*(S*S*S)*CCSL(5)*CCSR(6)*CSL(2)*CSR(3))/2.D0
     & + MB*MT*S*CCSR(4)*CCSR(6)*CSL(2)*CSR(3)
     & + 2.D0*C0b*MB*MB2*MT*S*CCSR(4)*CCSR(6)*CSL(2)*CSR(3)
     & + 2.D0*CC0t*MB*MT*MT2*S*CCSR(4)*CCSR(6)*CSL(2)*CSR(3)
     & + 4.D0*C0b*CC0t*MB*MB2*MT*MT2*S*CCSR(4)*CCSR(6)*CSL(2)*CSR(3)
     & + (-1.D0)*C0b*MB*MT*(S*S)*CCSR(4)*CCSR(6)*CSL(2)*CSR(3)/2.D0
     & + (-1.D0)*CC0t*MB*MT*(S*S)*CCSR(4)*CCSR(6)*CSL(2)*CSR(3)/2.D0
     & + (-1.D0)*C0b*CC0t*MB*MB2*MT*(S*S)*CCSR(4)*CCSR(6)*CSL(2)*CSR(3)
     & + (-1.D0)*C0b*CC0t*MB*MT*MT2*(S*S)*CCSR(4)*CCSR(6)*CSL(2)*CSR(3)
     & + MB2*S*CCSR(5)*CCSR(6)*CSL(2)*CSR(3)
     & + 4.D0*C0b*CC0b*(MB2*MB2*MB2)*S*CCSR(5)*CCSR(6)*CSL(2)*CSR(3)
     & + 4.D0*MB2*MB2*ReC0b*S*CCSR(5)*CCSR(6)*CSL(2)*CSR(3)
     & + (-2.D0)*C0b*CC0b*(MB2*MB2)*(S*S)*CCSR(5)*CCSR(6)*CSL(2)*CSR(3)
     & + (-1.D0)*MB2*ReC0b*(S*S)*CCSR(5)*CCSR(6)*CSL(2)*CSR(3)
     & + MT2*S*CCSL(4)*CCSR(6)*CSR(1)*CSR(3)
     & + 4.D0*C0t*CC0t*(MT2*MT2*MT2)*S*CCSL(4)*CCSR(6)*CSR(1)*CSR(3)
     & + 4.D0*MT2*MT2*ReC0t*S*CCSL(4)*CCSR(6)*CSR(1)*CSR(3)
     & + (-2.D0)*C0t*CC0t*(MT2*MT2)*(S*S)*CCSL(4)*CCSR(6)*CSR(1)*CSR(3)
     & + (-1.D0)*MT2*ReC0t*(S*S)*CCSL(4)*CCSR(6)*CSR(1)*CSR(3)
     & + MB*MT*S*CCSL(5)*CCSR(6)*CSR(1)*CSR(3)
     & + 2.D0*CC0b*MB*MB2*MT*S*CCSL(5)*CCSR(6)*CSR(1)*CSR(3)
     & + 2.D0*C0t*MB*MT*MT2*S*CCSL(5)*CCSR(6)*CSR(1)*CSR(3)
     & + 4.D0*C0t*CC0b*MB*MB2*MT*MT2*S*CCSL(5)*CCSR(6)*CSR(1)*CSR(3)
     & + (-1.D0)*C0t*MB*MT*(S*S)*CCSL(5)*CCSR(6)*CSR(1)*CSR(3)/2.D0
     & + (-1.D0)*CC0b*MB*MT*(S*S)*CCSL(5)*CCSR(6)*CSR(1)*CSR(3)/2.D0
     & + (-1.D0)*C0t*CC0b*MB*MB2*MT*(S*S)*CCSL(5)*CCSR(6)*CSR(1)*CSR(3)
     & + (-1.D0)*C0t*CC0b*MB*MT*MT2*(S*S)*CCSL(5)*CCSR(6)*CSR(1)*CSR(3)
     & + MT2*S*CCSR(4)*CCSR(6)*CSR(1)*CSR(3)
     & + 4.D0*C0t*CC0t*(MT2*MT2*MT2)*S*CCSR(4)*CCSR(6)*CSR(1)*CSR(3)
     & + 4.D0*MT2*MT2*ReC0t*S*CCSR(4)*CCSR(6)*CSR(1)*CSR(3)
     & + (-2.D0)*C0t*CC0t*(MT2*MT2)*(S*S)*CCSR(4)*CCSR(6)*CSR(1)*CSR(3)
     & + (-1.D0)*MT2*ReC0t*(S*S)*CCSR(4)*CCSR(6)*CSR(1)*CSR(3)
     & + (C0t*CC0t*MT2*(S*S*S)*CCSR(4)*CCSR(6)*CSR(1)*CSR(3))/2.D0
     & + MB*MT*S*CCSR(5)*CCSR(6)*CSR(1)*CSR(3)
     & + 2.D0*CC0b*MB*MB2*MT*S*CCSR(5)*CCSR(6)*CSR(1)*CSR(3)
     & + 2.D0*C0t*MB*MT*MT2*S*CCSR(5)*CCSR(6)*CSR(1)*CSR(3)
     & + 4.D0*C0t*CC0b*MB*MB2*MT*MT2*S*CCSR(5)*CCSR(6)*CSR(1)*CSR(3)
     & + (-1.D0)*C0t*MB*MT*(S*S)*CCSR(5)*CCSR(6)*CSR(1)*CSR(3)/2.D0
     & + (-1.D0)*CC0b*MB*MT*(S*S)*CCSR(5)*CCSR(6)*CSR(1)*CSR(3)/2.D0
     & + (-1.D0)*C0t*CC0b*MB*MB2*MT*(S*S)*CCSR(5)*CCSR(6)*CSR(1)*CSR(3)
     & + (-1.D0)*C0t*CC0b*MB*MT*MT2*(S*S)*CCSR(5)*CCSR(6)*CSR(1)*CSR(3)
     & + (C0t*CC0b*MB*MT*(S*S*S)*CCSR(5)*CCSR(6)*CSR(1)*CSR(3))/2.D0
     & + MB*MT*S*CCSL(4)*CCSR(6)*CSR(2)*CSR(3)
     & + 2.D0*C0b*MB*MB2*MT*S*CCSL(4)*CCSR(6)*CSR(2)*CSR(3)
     & + 2.D0*CC0t*MB*MT*MT2*S*CCSL(4)*CCSR(6)*CSR(2)*CSR(3)
     & + 4.D0*C0b*CC0t*MB*MB2*MT*MT2*S*CCSL(4)*CCSR(6)*CSR(2)*CSR(3)
     & + (-1.D0)*C0b*MB*MT*(S*S)*CCSL(4)*CCSR(6)*CSR(2)*CSR(3)/2.D0
     & + (-1.D0)*CC0t*MB*MT*(S*S)*CCSL(4)*CCSR(6)*CSR(2)*CSR(3)/2.D0
     & + (-1.D0)*C0b*CC0t*MB*MB2*MT*(S*S)*CCSL(4)*CCSR(6)*CSR(2)*CSR(3)
     & + (-1.D0)*C0b*CC0t*MB*MT*MT2*(S*S)*CCSL(4)*CCSR(6)*CSR(2)*CSR(3)
     & + MB2*S*CCSL(5)*CCSR(6)*CSR(2)*CSR(3)
     & + 4.D0*C0b*CC0b*(MB2*MB2*MB2)*S*CCSL(5)*CCSR(6)*CSR(2)*CSR(3)
     & + 4.D0*MB2*MB2*ReC0b*S*CCSL(5)*CCSR(6)*CSR(2)*CSR(3)
     & + (-2.D0)*C0b*CC0b*(MB2*MB2)*(S*S)*CCSL(5)*CCSR(6)*CSR(2)*CSR(3)
     & + (-1.D0)*MB2*ReC0b*(S*S)*CCSL(5)*CCSR(6)*CSR(2)*CSR(3)
     & + MB*MT*S*CCSR(4)*CCSR(6)*CSR(2)*CSR(3)
     & + 2.D0*C0b*MB*MB2*MT*S*CCSR(4)*CCSR(6)*CSR(2)*CSR(3)
     & + 2.D0*CC0t*MB*MT*MT2*S*CCSR(4)*CCSR(6)*CSR(2)*CSR(3)
     & + 4.D0*C0b*CC0t*MB*MB2*MT*MT2*S*CCSR(4)*CCSR(6)*CSR(2)*CSR(3)
     & + (-1.D0)*C0b*MB*MT*(S*S)*CCSR(4)*CCSR(6)*CSR(2)*CSR(3)/2.D0
     & + (-1.D0)*CC0t*MB*MT*(S*S)*CCSR(4)*CCSR(6)*CSR(2)*CSR(3)/2.D0
     & + (-1.D0)*C0b*CC0t*MB*MB2*MT*(S*S)*CCSR(4)*CCSR(6)*CSR(2)*CSR(3)
     & + (-1.D0)*C0b*CC0t*MB*MT*MT2*(S*S)*CCSR(4)*CCSR(6)*CSR(2)*CSR(3)
     & + (C0b*CC0t*MB*MT*(S*S*S)*CCSR(4)*CCSR(6)*CSR(2)*CSR(3))/2.D0
     & + MB2*S*CCSR(5)*CCSR(6)*CSR(2)*CSR(3)
     & + 4.D0*C0b*CC0b*(MB2*MB2*MB2)*S*CCSR(5)*CCSR(6)*CSR(2)*CSR(3)
     & + 4.D0*MB2*MB2*ReC0b*S*CCSR(5)*CCSR(6)*CSR(2)*CSR(3)
     & + (-2.D0)*C0b*CC0b*(MB2*MB2)*(S*S)*CCSR(5)*CCSR(6)*CSR(2)*CSR(3)
     & + (-1.D0)*MB2*ReC0b*(S*S)*CCSR(5)*CCSR(6)*CSR(2)*CSR(3)
     & + (C0b*CC0b*MB2*(S*S*S)*CCSR(5)*CCSR(6)*CSR(2)*CSR(3))/2.D0

      BWBWggtoff = Real(BW(1)*conjg(BW(2))*BWBWfactor)

      end



#ifdef HIGGSBOUNDS
!************************************************************** 
	subroutine get_singleH_uncertainty(dCS,dggh,dbbh,g2hgg,g2hbb,mh)
	use theory_colliderSfunctions

	implicit none	
	double precision dCS
 	double precision dggh, dbbh, g2hgg, g2hbb, mh
 	double precision vsmall

 	vsmall=1.0D-10

	if(g2hgg.le.vsmall.and.g2hbb.le.vsmall) then
		dCS = 0.0D0
	else 
		dCS=(g2hgg*LHC8_rH_gg(mh)*dggh+
     & 		g2hbb*LHC8_rH_bb(mh)*dbbh)/
     &      (g2hgg*LHC8_rH_gg(mh)+g2hbb*LHC8_rH_bb(mh))
	endif
	end
!************************************************************** 
#endif
